## glibc 2.40

=== benchtests/Makefile ===
# Copyright (C) 2013-2024 Free Software Foundation, Inc.
# Copyright The GNU Toolchain Authors.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# Makefile for benchmark tests.  The only useful target here is `bench`.
# Add benchmark functions in alphabetical order.

subdir := benchtests

include ../Makeconfig

bench-math := \
  acos \
  acosh \
  asin \
  asinh \
  atan \
  atan2 \
  atanh \
  cbrt \
  ceil \
  ceilf \
  cos \
  cosf \
  cosh \
  erf \
  erfc \
  exp \
  exp10 \
  exp10f \
  exp2 \
  exp2f \
  expf \
  expm1 \
  floor \
  floorf \
  fmax \
  fmaxf \
  fmin \
  fminf \
  fmod \
  fmodf \
  hypot \
  hypotf \
  ilogb \
  ilogbf \
  isfinite \
  isinf \
  isnan \
  j0 \
  j1 \
  lgamma \
  llrint \
  llrintf \
  log \
  log10 \
  log1p \
  log2 \
  log2f \
  logb \
  logbf \
  logf \
  lrint \
  lrintf \
  modf \
  nearbyint \
  nearbyintf \
  pow \
  powf \
  rint \
  rintf \
  roundeven \
  roundevenf \
  sin \
  sincos \
  sincosf \
  sinf \
  sinh \
  sqrt \
  tan \
  tanh \
  tgamma \
  trunc \
  truncf \
  y0 \
  y1 \
  # bench-math

ifneq (,$(filter yes,$(float96-fcts)))
bench-math += \
  cbrtl \
  # bench-math
endif

ifneq (,$(filter yes,$(float128-fcts) $(float128-alias-fcts)))
bench-math += \
  expf128 \
  ilogbf128 \
  powf128 \
  sinf128 \
  # bench-math
endif

bench-pthread := \
  pthread-locks \
  pthread-mutex-lock \
  pthread-mutex-trylock \
  pthread-spin-lock \
  pthread-spin-trylock \
  pthread_once \
  thread_create \
  # bench-pthread

LDLIBS-bench-pthread-mutex-lock += -lm
LDLIBS-bench-pthread-mutex-trylock += -lm
LDLIBS-bench-pthread-spin-lock += -lm
LDLIBS-bench-pthread-spin-trylock += -lm

bench-string := \
  ffs \
  ffsll \
  # bench-string

# String function benchmarks.
string-benchset := \
  bzero \
  bzero-large \
  memccpy \
  memchr \
  memcmp \
  memcmpeq \
  memcpy \
  memcpy-large \
  memcpy-random \
  memmem \
  memmove \
  memmove-large \
  mempcpy \
  memrchr \
  memset \
  memset-large \
  memset-zero \
  memset-zero-large \
  rawmemchr \
  stpcpy \
  stpcpy_chk \
  stpncpy \
  strcasecmp \
  strcasestr \
  strcat \
  strchr \
  strchrnul \
  strcmp \
  strcoll \
  strcpy \
  strcpy_chk \
  strcspn \
  strlen \
  strncasecmp \
  strncat \
  strncmp \
  strncpy \
  strnlen \
  strpbrk \
  strrchr \
  strsep \
  strspn \
  strstr \
  strtok \
  # string-benchset

# Build and run locale-dependent benchmarks only if we're building natively.
ifeq (no,$(cross-compiling))
wcsmbs-benchset := \
  wcpcpy \
  wcpncpy \
  wcrtomb \
  wcscat \
  wcschr \
  wcschrnul \
  wcscmp \
  wcscpy \
  wcscspn \
  wcslen \
  wcsncat \
  wcsncmp \
  wcsncpy \
  wcsnlen \
  wcspbrk \
  wcsrchr \
  wcsspn \
  wmemchr \
  wmemcmp \
  wmemset \
  # wcsmbs-benchset
else
wcsmbs-benchset :=
endif

string-benchset-all := $(string-benchset) ${wcsmbs-benchset}

ifeq (no,$(cross-compiling))
# We have to generate locales
LOCALES := \
  ar_SA.UTF-8 \
  cs_CZ.UTF-8 \
  da_DK.UTF-8 \
  el_GR.UTF-8 \
  en_GB.UTF-8 \
  en_US.UTF-8 \
  es_ES.UTF-8 \
  fa_IR.UTF-8 \
  fr_FR.UTF-8 \
  he_IL.UTF-8 \
  hi_IN.UTF-8 \
  hu_HU.UTF-8 \
  is_IS.UTF-8 \
  it_IT.UTF-8 \
  ja_JP.UTF-8 \
  pl_PL.UTF-8 \
  pt_PT.UTF-8 \
  ru_RU.UTF-8 \
  si_LK.UTF-8 \
  sr_RS.UTF-8 \
  sv_SE.UTF-8 \
  tr_TR.UTF-8 \
  vi_VN.UTF-8 \
  zh_CN.UTF-8 \
  # LOCALES
include ../gen-locales.mk
endif

hash-benchset := \
  dl-elf-hash \
  dl-new-hash \
  nss-hash \
  # hash-benchset

stdlib-benchset := \
  arc4random \
  random-lock \
  strtod \
  # stdlib-benchset

stdio-benchset := \
  fclose \
  # stdio-benchset

stdio-common-benchset := sprintf

math-benchset := math-inlines

ifeq (${BENCHSET},)
benchset := \
  $(hash-benchset) \
  $(math-benchset) \
  $(stdio-benchset) \
  $(stdio-common-benchset) \
  $(stdlib-benchset) \
  $(string-benchset-all) \
  # benchset
else
benchset := $(foreach B,$(filter %-benchset,${BENCHSET}), ${${B}})
endif

CFLAGS-bench-ffs.c += -fno-builtin
CFLAGS-bench-ffsll.c += -fno-builtin
CFLAGS-bench-sqrt.c += -fno-builtin
CFLAGS-bench-fmin.c += -fno-builtin
CFLAGS-bench-fminf.c += -fno-builtin
CFLAGS-bench-fmax.c += -fno-builtin
CFLAGS-bench-fmaxf.c += -fno-builtin
CFLAGS-bench-trunc.c += -fno-builtin
CFLAGS-bench-truncf.c += -fno-builtin
CFLAGS-bench-roundeven.c += -fno-builtin
CFLAGS-bench-roundevenf.c += -fno-builtin
CFLAGS-bench-isnan.c += $(config-cflags-signaling-nans)
CFLAGS-bench-isinf.c += $(config-cflags-signaling-nans)
CFLAGS-bench-isfinite.c += $(config-cflags-signaling-nans)

ifeq (${BENCHSET},)
bench-malloc := \
  malloc-simple \
  malloc-thread \
  # bench-malloc
else
bench-malloc := $(filter malloc-%,${BENCHSET})
endif

ifeq (${STATIC-BENCHTESTS},yes)
+link-benchtests = $(+link-static-tests)
link-libc-benchtests = $(link-libc-static)
libm-benchtests = $(common-objpfx)math/libm.a
thread-library-benchtests = $(static-thread-library)
else
link-libc-benchtests = $(link-libc)
+link-benchtests = $(+link-tests)
thread-library-benchtests = $(shared-thread-library)
libm-benchtests = $(libm)
endif

$(addprefix $(objpfx)bench-,$(bench-math)): $(libm-benchtests)
$(addprefix $(objpfx)bench-,$(math-benchset)): $(libm-benchtests)
$(addprefix $(objpfx)bench-,$(bench-pthread)): $(thread-library-benchtests)
$(addprefix $(objpfx)bench-,$(bench-malloc)): $(thread-library-benchtests)
$(addprefix $(objpfx)bench-,pthread-locks): $(libm-benchtests)
$(addprefix $(objpfx)bench-,pthread-mutex-locks): $(libm-benchtests)



# Rules to build and execute the benchmarks.  Do not put any benchmark
# parameters beyond this point.

# We don't want the benchmark programs to run in parallel since that could
# affect their performance.
.NOTPARALLEL:

bench-extra-objs = json-lib.o

extra-objs += $(bench-extra-objs)
others-extras = $(bench-extra-objs)

# The default duration: 1 seconds.
ifndef BENCH_DURATION
BENCH_DURATION := 1
endif

CPPFLAGS-nonlib += -DDURATION=$(BENCH_DURATION) -D_ISOMAC

# Use clock_gettime to measure performance of functions.  The default is
# to use the architecture-specific high precision timing instructions.
ifdef USE_CLOCK_GETTIME
CPPFLAGS-nonlib += -DUSE_CLOCK_GETTIME
else
# On x86 processors, use RDTSCP, instead of RDTSC, to measure performance
# of functions.  All x86 processors since 2010 support RDTSCP instruction.
ifdef USE_RDTSCP
CPPFLAGS-nonlib += -DUSE_RDTSCP
endif
endif

DETAILED_OPT :=

ifdef DETAILED
DETAILED_OPT := -d
endif

bench-deps := bench-skeleton.c bench-timing.h Makefile

run-bench = $(test-wrapper-env) \
	    $(run-program-env) \
	    $($*-ENV) $(test-via-rtld-prefix) $${run}

timing-type := $(objpfx)bench-timing-type
extra-objs += bench-timing-type.o

include ../Rules

bench-math += $(bench-libmvec)

ifeq (${BENCHSET},)
bench := \
  $(bench-math) \
  $(bench-pthread) \
  $(bench-string) \
  # bench
else
bench := $(foreach B,$(filter bench-%,${BENCHSET}), ${${B}})
endif

# NB: Use "=" instead of ":=" since sysdeps Makefiles may add more
# benches.
binaries-bench = $(addprefix $(objpfx)bench-,$(bench))
extra-objs += $(addsuffix .o,$(addprefix bench-,$(bench)))
binaries-benchset = $(addprefix $(objpfx)bench-,$(benchset))
extra-objs += $(addsuffix .o,$(addprefix bench-,$(benchset)))
binaries-bench-malloc := $(addprefix $(objpfx)bench-,$(bench-malloc))
extra-objs += $(addsuffix .o,$(addprefix bench-,$(bench-malloc)))

# This makes sure CPPFLAGS-nonlib and CFLAGS-nonlib are passed
# for all these modules.
cpp-srcs-left := \
  $(binaries-bench-malloc:=.c) \
  $(binaries-bench:=.c) \
  $(binaries-benchset:=.c) \
  $(timing-type:=.c) \
  # cpp-srcs-left
lib := nonlib
include $(patsubst %,$(..)libof-iterator.mk,$(cpp-srcs-left))

bench-clean:
	rm -f $(binaries-bench) $(addsuffix .o,$(binaries-bench))
	rm -f $(binaries-benchset) $(addsuffix .o,$(binaries-benchset))
	rm -f $(binaries-bench-malloc) $(addsuffix .o,$(binaries-bench-malloc))
	rm -f $(timing-type) $(addsuffix .o,$(timing-type))
	rm -f $(addprefix $(objpfx),$(bench-extra-objs))

# Validate the passed in BENCHSET
ifneq ($(strip ${BENCHSET}),)
VALIDBENCHSETNAMES := \
  bench-math \
  bench-pthread \
  bench-string \
  hash-benchset \
  malloc-simple \
  malloc-thread \
  math-benchset \
  stdio-benchset \
  stdio-common-benchset \
  stdlib-benchset \
  string-benchset \
  wcsmbs-benchset \
  # VALIDBENCHSETNAMES

INVALIDBENCHSETNAMES := $(filter-out ${VALIDBENCHSETNAMES},${BENCHSET})
ifneq (${INVALIDBENCHSETNAMES},)
$(info The following values in BENCHSET are invalid: ${INVALIDBENCHSETNAMES})
$(info The valid ones are: ${VALIDBENCHSETNAMES})
$(error Invalid BENCHSET value)
endif
endif

bench: bench-build bench-set bench-func bench-malloc

# Target to only build the benchmark without running it.  We generate locales
# only if we're building natively.
ifeq (no,$(cross-compiling))
bench-build: $(gen-locales) $(timing-type) $(binaries-bench) \
	$(binaries-benchset) $(binaries-bench-malloc)
else
bench-build: $(timing-type) $(binaries-bench) $(binaries-benchset) \
	$(binaries-bench-malloc)
endif

bench-set: $(binaries-benchset)
	for run in $^; do \
	  echo "Running $${run}"; \
	  $(run-bench) > $${run}.out; \
	done

bench-malloc: $(binaries-bench-malloc)
	for run in $^; do \
	  echo "$${run}"; \
	  if [ `basename $${run}` = "bench-malloc-thread" ]; then \
		for thr in 1 8 16 32; do \
			echo "Running $${run} $${thr}"; \
			$(run-bench) $${thr} > $${run}-$${thr}.out; \
		done;\
	  else \
		for thr in 8 16 32 64 128 256 512 1024 2048 4096; do \
		  echo "Running $${run} $${thr}"; \
		  $(run-bench) $${thr} > $${run}-$${thr}.out; \
		done;\
	  fi;\
	done

# Build and execute the benchmark functions.  This target generates JSON
# formatted bench.out.  Each of the programs produce independent JSON output,
# so one could even execute them individually and process it using any JSON
# capable language or tool.
bench-func: $(binaries-bench)
	if [ -n '$^' ] ; then \
	{ timing_type=$$($(test-wrapper-env) \
			 $(run-program-env) \
			 $(test-via-rtld-prefix) \
			 $(timing-type)); \
	  echo "{\"timing_type\": \"$${timing_type}\","; \
	  echo " \"functions\": {"; \
	  for run in $^; do \
	    op=$$($(run-bench) $(DETAILED_OPT)); \
	    ret=$$?; \
	    case "$${ret}" in \
	      77) \
	      echo "UNSUPPORTED $${run}: $${op}" >&2; \
		;; \
	      0) \
		echo "Running $${run}" >&2; \
		if [ "$${run}" != "$<" ]; then \
		  echo ","; \
		fi; \
		echo "$${op}"; \
		;; \
	      *) \
		echo "FAILED $${run}" >&2; \
		;; \
	    esac; \
	  done; \
	  echo; \
	  echo " }"; \
	  echo "}"; \
	  } > $(objpfx)bench.out-tmp; \
	  if [ -f $(objpfx)bench.out ]; then \
	    mv -f $(objpfx)bench.out $(objpfx)bench.out.old; \
	  fi; \
	  mv -f $(objpfx)bench.out-tmp $(objpfx)bench.out; \
	  $(PYTHON) scripts/validate_benchout.py $(objpfx)bench.out \
	  scripts/benchout.schema.json; \
	fi

ifeq ($(bind-now),yes)
link-bench-bind-now = -Wl,-z,now
endif

bench-link-targets = $(timing-type) $(binaries-bench) $(binaries-benchset) \
	$(binaries-bench-malloc)

$(bench-link-targets): %: %.o $(objpfx)json-lib.o \
	$(link-extra-libs-tests) \
  $(sort $(filter $(common-objpfx)lib%,$(link-libc-benchtests))) \
  $(addprefix $(csu-objpfx),start.o) $(+preinit) $(+postinit)
	$(+link-benchtests)

$(bench-link-targets): LDFLAGS += $(link-bench-bind-now)

$(objpfx)bench-%.c: %-inputs $(bench-deps)
	{ if [ -n "$($*-INCLUDE)" ]; then \
	  cat $($*-INCLUDE); \
	fi; \

=== htl/Makefile ===
#
#   Copyright (C) 1994-2024 Free Software Foundation, Inc.
#
#   The GNU C Library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License as published by the Free Software Foundation; either
#   version 2.1 of the License, or (at your option) any later version.

#   The GNU C Library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.

#   You should have received a copy of the GNU Lesser General Public
#   License along with the GNU C Library; if not, see
#   <https://www.gnu.org/licenses/>.

subdir := htl

srcdir = .

MICROKERNEL := mach
SYSDEPS := lockfile

LCLHDRS :=

libpthread-routines := \
  pt-attr \
  pt-attr-destroy \
  pt-attr-getguardsize \
  pt-attr-getscope \
  pt-attr-getstack \
  pt-attr-getstackaddr \
  pt-attr-getstacksize \
  pt-attr-init \
  pt-attr-setguardsize \
  pt-attr-setschedparam \
  pt-attr-setscope \
  pt-attr-setstack \
  pt-attr-setstackaddr \
  pt-attr-setstacksize \
  pt-barrier-destroy \
  pt-barrier-init \
  pt-barrier-wait \
  pt-barrier \
  pt-barrierattr-destroy \
  pt-barrierattr-init \
  pt-barrierattr-getpshared \
  pt-barrierattr-setpshared \
  pt-destroy-specific \
  pt-init-specific \
  pt-key-create \
  pt-key-delete \
  pt-getspecific \
  pt-setspecific \
  pt-once \
  pt-alloc \
  pt-create \
  pt-getattr \
  pt-dealloc \
  pt-detach \
  pt-exit \
  pt-initialize \
  pt-join \
  pt-sigmask \
  pt-spin-inlines \
  pt-cleanup \
  pt-setcancelstate \
  pt-setcanceltype \
  pt-testcancel \
  pt-cancel \
  pt-mutexattr-destroy \
  pt-mutexattr-init \
  pt-mutexattr-getprioceiling \
  pt-mutexattr-getprotocol \
  pt-mutexattr-getpshared \
  pt-mutexattr-gettype \
  pt-mutexattr-setprioceiling \
  pt-mutexattr-setprotocol \
  pt-mutexattr-setpshared \
  pt-mutexattr-settype \
  pt-mutexattr-getrobust \
  pt-mutexattr-setrobust \
  pt-mutex-init \
  pt-mutex-destroy \
  pt-mutex-checklocked \
  pt-mutex-lock \
  pt-mutex-trylock \
  pt-mutex-timedlock \
  pt-mutex-unlock \
  pt-mutex-transfer-np \
  pt-mutex-getprioceiling \
  pt-mutex-setprioceiling \
  pt-mutex-consistent \
  pt-rwlock-attr \
  pt-rwlockattr-init \
  pt-rwlockattr-destroy \
  pt-rwlockattr-getpshared \
  pt-rwlockattr-setpshared \
  pt-rwlock-init \
  pt-rwlock-destroy \
  pt-rwlock-rdlock \
  pt-rwlock-tryrdlock \
  pt-rwlock-trywrlock \
  pt-rwlock-wrlock \
  pt-rwlock-timedrdlock \
  pt-rwlock-timedwrlock \
  pt-rwlock-unlock \
  pt-cond \
  pt-condattr-init \
  pt-condattr-destroy \
  pt-condattr-getclock \
  pt-condattr-getpshared \
  pt-condattr-setclock \
  pt-condattr-setpshared \
  pt-cond-destroy \
  pt-cond-init \
  pt-cond-brdcast \
  pt-cond-signal \
  pt-cond-wait \
  pt-cond-timedwait \
  pt-hurd-cond-wait \
  pt-hurd-cond-timedwait \
  pt-stack-alloc \
  pt-thread-alloc \
  pt-thread-start \
  pt-thread-terminate \
  pt-startup \
  pt-getconcurrency \
  pt-setconcurrency \
  pt-block \
  pt-timedblock \
  pt-block-intr \
  pt-timedblock-intr \
  pt-wakeup \
  pt-docancel \
  pt-sysdep \
  pt-setup \
  pt-machdep \
  pt-spin \
  pt-sigstate-init \
  pt-sigstate-destroy \
  pt-sigstate \
  pt-kill \
  pt-getcpuclockid \
  pt-setschedprio \
  pt-yield \
  pt-getname-np \
  pt-setname-np \
  sem_close \
  sem-destroy \
  sem-getvalue \
  sem-init \
  sem_open \
  sem-post \
  sem-timedwait \
  sem-trywait \
  sem_unlink \
  sem-wait \
  sem-waitfast \
  sem_routines \
  cancellation \
  cthreads-compat \
  herrno \
  $(SYSDEPS) \
  # libpthread-routine

headers := \
  bits/cancelation.h \
  bits/pthread-np.h \
  bits/pthread.h \
  bits/pthreadtypes-arch.h \
  bits/pthreadtypes.h \
  bits/semaphore.h \
  bits/spin-lock-inline.h \
  bits/thread-shared-types.h \
  bits/types/__pthread_key.h \
  bits/types/__pthread_spinlock_t.h \
  bits/types/__pthread_t.h \
  bits/types/__thrd_t.h \
  bits/types/struct___pthread_attr.h \
  bits/types/struct___pthread_barrier.h \
  bits/types/struct___pthread_barrierattr.h \
  bits/types/struct___pthread_cond.h \
  bits/types/struct___pthread_condattr.h \
  bits/types/struct___pthread_mutex.h \
  bits/types/struct___pthread_mutexattr.h \
  bits/types/struct___pthread_once.h \
  bits/types/struct___pthread_rwlock.h \
  bits/types/struct___pthread_rwlockattr.h \
  pthread.h \
  semaphore.h \
  # headers

distribute :=

routines := \
  alloca_cutoff \
  forward \
  htlfreeres \
  libc_pthread_init \
  pt-attr-getdetachstate \
  pt-attr-getinheritsched \
  pt-attr-getschedparam \
  pt-attr-getschedpolicy \
  pt-attr-setdetachstate \
  pt-attr-setinheritsched \
  pt-attr-setschedpolicy \
  pt-getschedparam \
  pt-nthreads \
  pt-pthread_self \
  pt-self pt-equal \
  pt-setschedparam \
  # routines
shared-only-routines = forward

extra-libs := libpthread
extra-libs-others := $(extra-libs)
install-lib := libpthread.so
install-lib-ldscripts := libpthread_syms.a

include ../Makeconfig

CFLAGS-lockfile.c = -D_IO_MTSAFE_IO

all: # Make this the default target; it will be defined in Rules.

subdir_install: $(inst_libdir)/libpthread2.a $(inst_libdir)/libpthread_syms.a

# XXX: If $(inst_libdir)/libpthread2.a is installed and
# $(inst_libdir)/libpthread is not, we can have some issues.
.PHONY: $(inst_libdir)/libpthread.a $(inst_libdir)/libpthread_pic.a

# XXX: These rules are a hack.  But it is better than messing with
# ../Makeconf at the moment.  Note that the linker scripts
# $(srcdir)/libpthread.a and $(srcdir)/libpthread_pic.a get overwritten
# when building in $(srcdir) and not a separate build directory.
$(inst_libdir)/libpthread2.a: $(inst_libdir)/libpthread.a
	mv $< $@
	$(INSTALL_DATA) $(srcdir)/libpthread.a $<

$(inst_libdir)/libpthread2_pic.a: $(inst_libdir)/libpthread_pic.a
	mv $< $@
	$(INSTALL_DATA) $(srcdir)/libpthread_pic.a $<

$(inst_libdir)/libpthread_syms.a: $(srcdir)/libpthread_syms.a $(+force)
	$(do-install)

libc-link.so = $(common-objpfx)libc.so

extra-B-pthread.so = -B$(common-objpfx)htl/
LDFLAGS-pthread.so = -Wl,--enable-new-dtags,-z,nodelete,-z,initfirst

include ../Rules

# Make sure we link with the thread library.
ifeq ($(build-shared),yes)
$(addprefix $(objpfx), \
  $(filter-out $(tests-static) $(xtests-static) $(tests-reverse) \
    $(tests-nolibpthread), \
    $(tests) $(tests-internal) $(xtests) $(test-srcs) $(tests-container))): \
	$(objpfx)libpthread.so
# $(objpfx)../libc.so is used instead of $(common-objpfx)libc.so,
# since otherwise libpthread.so comes before libc.so when linking.
$(addprefix $(objpfx), $(tests-reverse)): \
  $(objpfx)../libc.so $(objpfx)libpthread.so
$(objpfx)../libc.so: $(common-objpfx)libc.so ;
$(addprefix $(objpfx),$(tests-static) $(xtests-static)): $(srcdir)/libpthread_syms.a $(objpfx)libpthread.a
else
$(addprefix $(objpfx),$(tests) $(test-srcs)): $(srcdir)/libpthread_syms.a $(objpfx)libpthread.a
endif

=== iconvdata/Makefile ===
# Copyright (C) 1997-2024 Free Software Foundation, Inc.
# Copyright The GNU Toolchain Authors.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Makefile for iconv data and code.
#
subdir	:= iconvdata

include ../Makeconfig

# Names of all the shared objects which implement the transformations.
modules	:= ISO8859-1 ISO8859-2 ISO8859-3 ISO8859-4 ISO8859-5		 \
	   ISO8859-6 ISO8859-7 ISO8859-8 ISO8859-9 ISO8859-10		 \
	   ISO8859-11 ISO8859-13 ISO8859-14 ISO8859-15 ISO8859-16	 \
	   T.61 ISO_6937 SJIS KOI-8 HP-ROMAN8 HP-ROMAN9 EBCDIC-AT-DE	 \
	   EBCDIC-AT-DE-A EBCDIC-CA-FR EUC-KR UHC JOHAB libJIS libKSC	 \
	   BIG5 EUC-JP libGB EUC-CN libCNS EUC-TW ISO646 EBCDIC-DK-NO	 \
	   EBCDIC-DK-NO-A EBCDIC-ES EBCDIC-ES-A EBCDIC-ES-S EBCDIC-FI-SE \
	   EBCDIC-FI-SE-A EBCDIC-FR EBCDIC-IS-FRISS EBCDIC-IT EBCDIC-PT	 \
	   EBCDIC-UK EBCDIC-US IBM037 IBM038 IBM274 IBM275 IBM423	 \
	   IBM500 IBM870 IBM871 IBM891 IBM903 IBM904 IBM905 IBM1047	 \
	   IBM874 CP737 CP775 ISO-2022-KR HP-TURKISH8 HP-THAI8 HP-GREEK8 \
	   KOI8-R LATIN-GREEK LATIN-GREEK-1 IBM256 IBM273 IBM277 IBM278	 \
	   IBM280 IBM281 IBM284 IBM285 IBM290 IBM297 IBM420 IBM424	 \
	   IBM437 IBM850 IBM851 IBM852 IBM855 IBM857 IBM858 IBM860	 \
	   IBM861 IBM862 IBM863 IBM864 IBM865 IBM868 IBM869 IBM875	 \
	   IBM880 IBM866 CP1258 IBM922 IBM1124 IBM1129 IBM932 IBM943	 \
	   IBM856 IBM930 IBM933 IBM935 IBM937 IBM939 IBM1046		 \
	   IBM1132 IBM1133 IBM1160 IBM1161 IBM1162 IBM1163 IBM1164	 \
	   IBM918 IBM1004 IBM1026 CP1125 CP1250 CP1251 CP1252 CP1253	 \
	   CP1254 CP1255 CP1256 CP1257 ISO-2022-JP MACINTOSH IEC_P27-1	 \
	   ASMO_449 ANSI_X3.110 CSN_369103 CWI DEC-MCS ECMA-CYRILLIC	 \
	   GOST_19768-74 GREEK-CCITT GREEK7 GREEK7-OLD INIS INIS-8	 \
	   INIS-CYRILLIC ISO_6937-2 ISO_2033 ISO_5427 ISO_5427-EXT	 \
	   ISO_5428 ISO_10367-BOX MAC-IS MAC-UK NATS-DANO NATS-SEFI	 \
	   SAMI-WS2 ISO-IR-197 TIS-620 KOI8-U GBK ISIRI-3342 GBGBK	 \
	   ISO-2022-CN libISOIR165 UTF-16 UNICODE UTF-32 UTF-7 BIG5HKSCS \
	   GB18030 ISO-2022-CN-EXT VISCII GBBIG5 CP10007 KOI8-T		 \
	   GEORGIAN-PS GEORGIAN-ACADEMY ISO-IR-209 MAC-SAMI ARMSCII-8	 \
	   TCVN5712-1 libJISX0213 EUC-JISX0213 SHIFT_JISX0213		 \
	   ISO-2022-JP-3 TSCII IBM866NAV CP932 EUC-JP-MS PT154 RK1048	 \
	   IBM1025 IBM1122 IBM1137 IBM1153 IBM1154 IBM1155 IBM1156	 \
	   IBM1157 IBM1158 IBM803 IBM901 IBM902 IBM921 IBM1008		 \
	   IBM1008_420 IBM1097 IBM1112 IBM1123 IBM1130 IBM1140 IBM1141	 \
	   IBM1142 IBM1143 IBM1144 IBM1145 IBM1146 IBM1147 IBM1148	 \
	   IBM1149 IBM1166 IBM1167 IBM4517 IBM4899 IBM4909 IBM4971	 \
	   IBM5347 IBM9030 IBM9066 IBM9448 IBM12712 IBM16804             \
	   IBM1364 IBM1371 IBM1388 IBM1390 IBM1399 ISO_11548-1 MIK BRF	 \
	   MAC-CENTRALEUROPE KOI8-RU ISO8859-9E				 \
	   CP770 CP771 CP772 CP773 CP774

# If lazy binding is disabled, use BIND_NOW for the gconv modules.
ifeq ($(bind-now),yes)
LDFLAGS.so += -Wl,-z,now
endif

modules.so := $(addsuffix .so, $(modules))

ifeq (yes,$(build-shared))
tests = bug-iconv1 bug-iconv2 tst-loading tst-e2big tst-iconv4 bug-iconv4 \
	tst-iconv6 bug-iconv5 bug-iconv6 tst-iconv7 bug-iconv8 bug-iconv9 \
	bug-iconv10 bug-iconv11 bug-iconv12 tst-iconv-big5-hkscs-to-2ucs4 \
	bug-iconv13 bug-iconv14 bug-iconv15 \
	tst-iconv-iso-2022-cn-ext
ifeq ($(have-thread-library),yes)
tests += bug-iconv3
endif

test-srcs := tst-table-from tst-table-to
endif

libJIS-routines := jis0201 jis0208 jis0212
libKSC-routines := ksc5601
libGB-routines := gb2312
libCNS-routines := cns11643l1 cns11643
libISOIR165-routines := iso-ir-165
libJISX0213-routines := jisx0213

LDFLAGS-EUC-KR.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-KR.so: $(objpfx)libKSC.so
LDFLAGS-JOHAB.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)JOHAB.so: $(objpfx)libKSC.so
LDFLAGS-UHC.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)UHC.so: $(objpfx)libKSC.so
LDFLAGS-EUC-JP.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-JP.so: $(objpfx)libJIS.so
LDFLAGS-EUC-JP-MS.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-JP-MS.so: $(objpfx)libJIS.so
LDFLAGS-EUC-CN.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-CN.so: $(objpfx)libGB.so
LDFLAGS-EUC-TW.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-TW.so: $(objpfx)libCNS.so
LDFLAGS-EUC-JISX0213.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-JISX0213.so: $(objpfx)libJISX0213.so
LDFLAGS-SHIFT_JISX0213.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)SHIFT_JISX0213.so: $(objpfx)libJISX0213.so

LDFLAGS-ISO-2022-JP.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)ISO-2022-JP.so: $(objpfx)libJIS.so $(objpfx)libGB.so \
			 $(objpfx)libCNS.so $(objpfx)libKSC.so
LDFLAGS-ISO-2022-JP-3.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)ISO-2022-JP-3.so: $(objpfx)libJIS.so $(objpfx)libJISX0213.so
LDFLAGS-ISO-2022-KR.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)ISO-2022-KR.so: $(objpfx)libKSC.so
LDFLAGS-ISO-2022-CN.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)ISO-2022-CN.so: $(objpfx)libGB.so $(objpfx)libCNS.so
LDFLAGS-ISO-2022-CN-EXT.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)ISO-2022-CN-EXT.so: $(objpfx)libGB.so $(objpfx)libCNS.so \
			     $(objpfx)libISOIR165.so

LDFLAGS-libJIS.so = $(LDFLAGS-soname-fname)
LDFLAGS-libKSC.so = $(LDFLAGS-soname-fname)
LDFLAGS-libGB.so = $(LDFLAGS-soname-fname)
LDFLAGS-libCNS.so = $(LDFLAGS-soname-fname)
LDFLAGS-libISOIR165.so = $(LDFLAGS-soname-fname)
LDFLAGS-libJISX0213.so = $(LDFLAGS-soname-fname)

# We build the transformation modules only when we build shared libs.
ifeq (yes,$(build-shared))

# Rule to generate the shared objects.
charmaps = ../localedata/charmaps
-include $(objpfx)iconv-rules
extra-modules-left := $(modules)
include extra-module.mk

gconv-modules = gconv-modules gconv-modules.d/gconv-modules-extra.conf
modpfx = $(objpfx)gconv-modules.d/

extra-objs	+= $(modules.so)
install-others	= $(addprefix $(inst_gconvdir)/, $(modules.so))	\
		  $(addprefix $(inst_gconvdir)/, $(gconv-modules))

# We can build the conversion tables for numerous charsets automatically.

gen-8bit-modules := iso8859-2 iso8859-3 iso8859-4 iso8859-6 iso8859-9 koi-8 \
		    ebcdic-at-de ebcdic-at-de-a ebcdic-ca-fr ebcdic-dk-no   \
		    ebcdic-dk-no-a ebcdic-es-s ebcdic-fi-se ebcdic-fi-se-a  \
		    ebcdic-fr ebcdic-it ebcdic-pt ebcdic-us \
		    ibm037 ibm038 ibm274 ibm275 ibm423 ibm500 ibm870 ibm871 \
		    ibm891 ibm903 ibm904 ibm905 ibm1047

gen-8bit-gap-modules := koi8-r latin-greek latin-greek-1 ibm256 ibm273	   \
			ibm277 ibm278 ibm280 ibm281 ibm284 ibm285 ibm290   \
			ibm297 ibm420 ibm424 ibm437 ibm850 ibm851 ibm852   \
			ibm855 ibm857 ibm858 ibm860 ibm861 ibm862 ibm863   \
			ibm864 ibm865 ibm868 ibm869 ibm875 ibm880 ibm918   \
			ibm1004 ibm1026 cp1125 cp1250 cp1251 cp1252 cp1253 \
			cp1254 cp1256 cp1257 ibm866 iso8859-5 iso8859-7    \
			iso8859-8 iso8859-10 macintosh iec_p27-1 asmo_449  \
			csn_369103 cwi dec-mcs ecma-cyrillic gost_19768-74 \
			greek-ccitt greek7 greek7-old inis inis-8	   \
			inis-cyrillic iso_2033 iso_5427 iso_5427-ext	   \
			iso_5428 iso_10367-box mac-is nats-dano nats-sefi  \
			iso8859-13 iso8859-14 iso8859-15 mac-uk sami-ws2   \
			iso-ir-197 tis-620 koi8-u ibm874 cp10007 koi8-t	   \
			georgian-ps georgian-academy iso-ir-209 mac-sami   \
			iso8859-11 ibm866nav pt154 rk1048 mik brf	   \
			mac-centraleurope koi8-ru hp-roman8 hp-roman9	   \
			ebcdic-es ebcdic-es-a ebcdic-is-friss ebcdic-uk    \
			iso8859-16 viscii iso8859-9e hp-turkish8	   \
			hp-thai8 hp-greek8 cp770 cp771 cp772 cp773 cp774


gen-special-modules := iso8859-7jp

generated-modules := $(gen-8bit-modules) $(gen-8bit-gap-modules) \
		     $(gen-special-modules)

generated += $(generated-modules:=.h) $(generated-modules:=.stmp) \
	     iconv-test.out iconv-rules tst-loading.mtrace	 \
	     mtrace-tst-loading.out tst-tables.out iconv-test.xxx
ifdef objpfx
generated += $(gconv-modules)
endif

# Rules to generate the headers.
export AWK

define generate-8bit-table
$(make-target-directory)
LC_ALL=C $(SHELL) ./gen-8bit.sh $< > $(@:stmp=T)
$(move-if-change) $(@:stmp=T) $(@:stmp=h)
touch $@
endef

define generate-8bit-gap-table
$(make-target-directory)
LC_ALL=C $(SHELL) ./gen-8bit-gap.sh $< > $(@:stmp=T)
$(move-if-change) $(@:stmp=T) $(@:stmp=h)
touch $@
endef

# The headers must be generated before the compilation.
before-compile += $(addprefix $(objpfx),$(generated-modules:=.h))

ifndef avoid-generated
$(objpfx)iconv-rules: Makefile
	$(make-target-directory)
	{ echo $(filter-out lib%, $(modules)); \
	  echo 8bit $(gen-8bit-modules); \
	  echo 8bit-gap $(gen-8bit-gap-modules); } | \
	LC_ALL=C \
	$(AWK) 'NR == 1 { \
		  for (i = 1; i <= NF; i++) { \
		    printf "%s-routines := %s\n", $$i, tolower($$i); \
		    printf "libof-%s := iconvdata\n", tolower($$i); \
		    printf "%s-map := gconv.map\n", $$i; \
		  } \
		}; \
		NR > 1 { \
		  for (i = 2; i <= NF; i++) { \
		    printf "$$(objpfx)%s.stmp: ", $$i; \
		    map = toupper($$i); \
		    sub(/^ISO8859/, "ISO-8859", map); \
		    if (map == "ISO_2033") map = map "-1983"; \
		    printf "$$(charmaps)/%s ", map; \
		    printf "gen-%s.sh\n", $$1; \
		    printf "\t$$(generate-%s-table)\n", $$1; \
		  } \
		}' > $@.new
	mv -f $@.new $@
endif

$(generated-modules:%=$(objpfx)%.h): $(objpfx)%.h: $(objpfx)%.stmp
	@:

$(gen-8bit-modules:%=$(objpfx)%.stmp): $(objpfx)%.stmp: $(objpfx)iconv-rules
$(gen-8bit-gap-modules:%=$(objpfx)%.stmp): $(objpfx)%.stmp: $(objpfx)iconv-rules

$(objpfx)iso8859-7jp.stmp: $(charmaps)/ISO-8859-7 gen-8bit-gap-1.sh
	$(make-target-directory)
	LC_ALL=C $(SHELL) ./gen-8bit-gap-1.sh $< > $(@:stmp=T)
	$(move-if-change) $(@:stmp=T) $(@:stmp=h)
	touch $@

headers: $(addprefix $(objpfx), $(generated-modules:=.h))

$(addprefix $(inst_gconvdir)/, $(modules.so)): \
    $(inst_gconvdir)/%: $(objpfx)% $(+force)
	$(do-install-program)
$(addprefix $(inst_gconvdir)/, $(gconv-modules)): \
    $(inst_gconvdir)/%: $(objpfx)% $(+force)
	$(do-install)
ifeq (no,$(cross-compiling))
# Update the $(prefix)/lib/gconv/gconv-modules.cache file. This is necessary
# if this libc has more gconv modules than the previously installed one.
	if test -f "$(inst_gconvdir)/gconv-modules.cache"; then \
	   LC_ALL=C \
	   $(rtld-prefix) \
	   $(common-objpfx)iconv/iconvconfig \
	     $(addprefix --prefix=,$(install_root)); \
	fi
else
	@echo '*@*@*@ You should recreate $(inst_gconvdir)/gconv-modules.cache'
endif

endif # build-shared = yes

ifeq ($(run-built-tests),yes)
ifeq (yes,$(build-shared))
tests-special += $(objpfx)iconv-test.out $(objpfx)tst-tables.out
ifneq (no,$(PERL))
tests-special += $(objpfx)mtrace-tst-loading.out
endif
endif
endif

ifeq ($(run-built-tests),yes)
LOCALES := \
	de_DE.UTF-8 \
	zh_HK.BIG5-HKSCS \
	$(NULL)

include ../gen-locales.mk

$(objpfx)bug-iconv6.out: $(gen-locales)
$(objpfx)tst-iconv7.out: $(gen-locales)
$(objpfx)tst-iconv-big5-hkscs-to-2ucs4.out: $(gen-locales)
endif

include ../Rules

# Set libof-* for each routine.
cpp-srcs-left := $(modules) $(generated-modules) $(libJIS-routines) \
		 $(libKSC-routines) $(libGB-routines) $(libCNS-routines) \
		 $(libISOIR165-routines) $(libJISX0213-routines)
lib := iconvdata
include $(patsubst %,$(..)libof-iterator.mk,$(cpp-srcs-left))

tst-loading-ENV = MALLOC_TRACE=$(objpfx)tst-loading.mtrace \
		  LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
$(objpfx)mtrace-tst-loading.out: $(objpfx)tst-loading.out
	$(common-objpfx)malloc/mtrace $(objpfx)tst-loading.mtrace > $@; \
	$(evaluate-test)

$(objpfx)bug-iconv1.out: $(addprefix $(objpfx), $(gconv-modules)) \

=== mach/Makefile ===
# Copyright (C) 1991-2024 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

subdir := mach

include ../Makeconfig

headers = mach_init.h mach.h mach_error.h mach-shortcuts.h mach/mach_traps.h \
	  $(interface-headers) mach/mach.h mach/mig_support.h mach/error.h \
	  $(lock-headers) machine-sp.h bits/mach/param.h
lock = spin-solid spin-lock mutex-init mutex-solid
lock-headers = lock-intern.h spin-lock.h
routines = $(mach-syscalls) $(mach-shortcuts) \
	   mach_init mig_strncpy mig_strlen mig_memcpy msg \
	   mig-alloc mig-dealloc mig-reply \
	   msg-destroy msgserver \
	   mach_error errstring error_compat errsystems \
	   devstream setup-thread $(lock)

# The RPC interfaces go in a separate library.
interface-library := libmachuser

# We produce mach_interface.h from mach.defs because there is already a
# <mach/mach.h> that is not the interface header (thanks CMU).
mach-interface-list := $(patsubst mach,mach_interface,$(mach-interface-list))
mach/mach_interface.defs = mach/mach.defs

# Similarly for memory_object_user vs. memory_object
mach-interface-list := $(patsubst memory_object,memory_object_user,\
				  $(mach-interface-list))
mach/memory_object_user.defs = mach/memory_object.defs

user-interfaces := $(addprefix mach/,$(mach-interface-list)	\
			       	     mach_port mach_host exc	\
		    )\
		   $(addprefix device/,device device_request)

server-interfaces := mach/exc

# Clear any environment	value.
generated =

# Avoid ssp before TLS is initialized.
CFLAGS-mach_init.o = $(no-stack-protector)
CFLAGS-RPC_vm_statistics.o = $(no-stack-protector)
CFLAGS-RPC_vm_map.o = $(no-stack-protector)
CFLAGS-RPC_vm_protect.o = $(no-stack-protector)
CFLAGS-RPC_i386_set_gdt.o = $(no-stack-protector)
CFLAGS-RPC_i386_set_ldt.o = $(no-stack-protector)
CFLAGS-RPC_task_get_special_port.o = $(no-stack-protector)
CFLAGS-RPC_thread_set_state.o = $(no-stack-protector)

# Translate GNU names for CPUs into the names used in Mach header files.
mach-machine = $(patsubst powerpc,ppc,$(base-machine))

# Define mach-syscalls and sysno-*.
ifndef inhibit_mach_syscalls
-include $(objpfx)mach-syscalls.mk
endif
$(objpfx)mach-syscalls.mk: syscalls.awk Makefile libc-modules.h
# Go kludges!!!
	$(make-target-directory)
# We must use $(CFLAGS) to get -O flags that affect #if's in header files.
	echo '#include <mach/syscall_sw.h>' | \
	$(CC) $(CFLAGS) $(CPPFLAGS) -E -MD -MP -MF $@-dep -MT $@ \
	      -x c-header - \
	      -D_MACH_`echo $(mach-machine) | tr a-z A-Z`_SYSCALL_SW_H_=1 | \
	sed -n -e 's/^kernel_trap(\(.*\),\([-0-9]*\),\([0-9]*\))$$/\1 \2 \3/p'\
	| $(AWK) -f $< > $@-new
ifneq (,$(objpfx))
	sed $(sed-remove-objpfx) $@-dep >> $@-new
else
	cat $@-dep >> $@-new
endif
	rm -f $@-dep
	mv -f $@-new $@
generated += mach-syscalls.mk

ifndef mach-syscalls
# We cannot make the deps properly until we know how to make the system
# call functions, and for that we must know what they all are.
no_deps=t
else
$(mach-syscalls:%=$(objpfx)%.S): $(objpfx)%.S: $(objpfx)mach-syscalls.mk
	(echo '#include <sysdep.h>'; \
	 echo 'kernel_trap (__$*,$(sysno-$*),$(nargs-$*))'; \
	 echo 'weak_alias (__$*, $*)'; \
	 echo 'libc_hidden_def (__$*)') > $@-new
	 mv -f $@-new $@
generated += $(mach-syscalls:=.S)
endif	# mach-syscalls

# These syscalls that look like RPCs actually have no RPC equivalents.
mach-shortcuts := $(filter-out device_writev_request \
			       device_read_overwrite_request \
			       device_read_overwrite \
			       vm_read_overwrite \
			       thread_switch \
			       ,\
		  $(patsubst syscall_%,%,$(filter syscall_%,$(mach-syscalls))))

ifndef mach-shortcuts
# Forget about mach_interface.defs for this run.  On the next run,
# $(mach-shortcuts) will be set, and that will change how
# mach_interface.defs is processed: it will get the -D flags below.
user-interfaces := $(filter-out $(mach-interface-list:%=mach/%) \
				mach/mach_port mach/mach_host mach/mach4 mach/gnumach \
				device/device_request,\
				$(user-interfaces))
endif

# For some reason, the calls in this file are `protected' by an ifdef.
MIGFLAGS-mach/mach4 = -DMACH_PCSAMPLE
MIGFLAGS-device/device = -DDEVICE_ENABLE_DEVICE_OPEN_NEW

# Make the MiG stubs for $(mach-shortcuts) be CALL_rpc.
migdefines += $(foreach call,$(mach-shortcuts),-D$(call)=$(call)_rpc)
$(mach-interface-list:%=mach/%.uh) \
  mach/mach_host.uh mach/mach_port.uh: $(objpfx)mach-syscalls.mk

ifdef mach-shortcuts
$(mach-shortcuts:%=$(objpfx)%.c): $(objpfx)%.c: shortcut.awk \
						$(objpfx)RPC_%_rpc.c
	$(AWK)	-v alias=$* -v call=__$* -v rpc=__$*_rpc \
		-v syscall=__syscall_$* -f $^ > $@-new
	mv -f $@-new $@
generated += $(mach-shortcuts:%=%.c)
endif	# mach-shortcuts

# Generate mach-shortcuts.h, which will contain the prototypes for the
# shortcutted kernel RPC functions.
$(objpfx)mach-shortcuts.h: $(mach-interface-list:%=$(objpfx)mach/%.h) \
			   $(objpfx)mach/mach_host.h \
			   $(objpfx)mach/mach_port.h
# The first line gets us one paragraph per line, with @s separating real lines.
# The second line selects paragraphs for the shortcutted functions.
# The third line removes `_rpc' from the names and reconstitutes the lines.
	( echo "#include <mach/mach_types.h>" ; \
	  echo "#include <mach/message.h>" ; \
	  echo ; \
	  cat $^ | tr \\012 @ | sed s/@@/@%/g | tr % \\012 \
	  | grep '^/\* Routine [a-z0-9_]*_rpc \*/' \
	  | sed 's/_rpc//g' | tr @ \\012 ) > $@-new
	mv -f $@-new $@
generated += mach-shortcuts.h

before-compile += $(objpfx)mach-shortcuts.h

include Machrules
include ../Rules


# A gcc bug prevents the generated file from working properly,
# so we have one in the distribution for the time being.
generated += errsystems.c
$(objpfx)errsystems.c: errsystems.awk err_*.sub \
		       $(wildcard $(addsuffix /err_*.sub,$(+sysdep_dirs)))
	$(AWK) -v subsys='$(filter-out $<,$^)' -f $^ > $@.n
	mv -f $@.n $@


# Convenient target to update all the generated source files.
.PHONY: generated
generated: $(addprefix $(common-objpfx),$(common-generated)) \
	   $(addprefix $(objpfx),$(generated))

.PHONY: mach-before-compile
mach-before-compile: $(mach-before-compile)

=== misc/Makefile ===
# Copyright (C) 1991-2024 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for misc portion of the library.
#

subdir	:= misc

include ../Makeconfig

headers	:= \
  sys/uio.h \
  bits/uio-ext.h \
  bits/uio_lim.h \
  sys/ioctl.h \
  bits/ioctls.h \
  bits/ioctl-types.h \
  sys/ptrace.h \
  sys/file.h \
  sys/dir.h \
  sys/cdefs.h \
  ar.h \
  a.out.h \
  libgen.h \
  stab.h \
  bits/stab.def \
  sgtty.h \
  ttyent.h \
  paths.h \
  sys/reboot.h \
  sys/mman.h \
  sys/param.h \
  bits/param.h \
  fstab.h \
  mntent.h \
  search.h \
  err.h \
  error.h \
  sys/queue.h \
  sysexits.h \
  syscall.h \
  sys/syscall.h \
  sys/swap.h \
  sys/select.h \
  sys/sysinfo.h \
  regexp.h \
  bits/select.h \
  bits/mman.h \
  sys/xattr.h \
  syslog.h \
  sys/syslog.h \
  bits/syslog-decl.h \
  bits/syslog.h \
  bits/syslog-ldbl.h \
  bits/syslog-path.h \
  bits/error.h \
  bits/select-decl.h \
  bits/select2.h \
  bits/hwcap.h \
  sys/auxv.h \
  sys/sysmacros.h \
  bits/sysmacros.h \
  bits/types/struct_iovec.h \
  bits/err-ldbl.h \
  bits/error-ldbl.h \
  sys/single_threaded.h \
  # headers

routines := \
  acct \
  allocate_once \
  atomic_wide_counter \
  brk \
  chflags \
  chroot \
  daemon \
  dirname \
  efgcvt \
  efgcvt_r \
  err \
  error \
  fchflags \
  fd_to_filename \
  fdatasync \
  fgetxattr \
  flistxattr \
  fremovexattr \
  fsetxattr \
  fstab \
  fsync \
  ftruncate \
  ftruncate64 \
  futimes \
  futimesat \
  getauxval \
  getclktck \
  getdomain \
  getdtsz \
  gethostid \
  gethostname \
  getloadavg \
  getpagesize \
  getpass \
  getsysstats \
  getttyent \
  getusershell \
  getxattr \
  gtty \
  hsearch \
  hsearch_r \
  ifunc-impl-list \
  insremque \
  ioctl \
  lgetxattr \
  listxattr \
  llistxattr \
  lremovexattr \
  lsearch \
  lsetxattr \
  lutimes \
  madvise \
  makedev \
  mincore \
  mkdtemp \
  mkostemp \
  mkostemp64 \
  mkostemps \
  mkostemps64 \
  mkstemp \
  mkstemp64 \
  mkstemps \
  mkstemps64 \
  mktemp \
  mlock \
  mlockall \
  mmap \
  mmap64 \
  mntent \
  mntent_r \
  mprotect \
  msync \
  munlock \
  munlockall \
  munmap \
  preadv \
  preadv2 \
  preadv64 \
  preadv64v2 \
  pselect \
  ptrace \
  pwritev \
  pwritev2 \
  pwritev64 \
  pwritev64v2 \
  qefgcvt \
  qefgcvt_r \
  readv \
  reboot \
  regexp \
  remap_file_pages \
  removexattr \
  revoke \
  sbrk \
  select \
  setdomain \
  setegid \
  seteuid \
  sethostid \
  sethostname \
  setregid \
  setreuid \
  setxattr \
  single_threaded \
  sstk \
  stty \
  swapoff \
  swapon \
  sync \
  syncfs \
  syscall \
  syslog \
  truncate \
  truncate64 \
  tsearch \
  ttyslot \
  ualarm \
  unwind-link \
  usleep \
  ustat \
  utimes \
  vhangup \
  writev \
  # routines

# Exclude fortified routines from being built with _FORTIFY_SOURCE
routines_no_fortify += \
  getdomain \
  gethostname \
  syslog \
  # routines_no_fortify

ifeq ($(run-built-tests),yes)
ifeq (yes,$(build-shared))
ifneq ($(PERL),no)
generated += \
  tst-allocate_once-mem.out \
  tst-allocate_once.mtrace \
  tst-error1-mem.out \
  tst-error1.mtrace \
  # generated
endif
endif
endif

aux := init-misc
install-lib := libg.a

gpl2lgpl := \
  error.c \
  error.h \
  # gpl2lgpl

tests := \
  bug-hsearch1 \
  bug18240 \
  tst-dbl-efgcvt \
  tst-dirname \
  tst-empty \
  tst-error1 \
  tst-fdset \
  tst-hsearch \
  tst-insremque \
  tst-ioctl \
  tst-ldbl-efgcvt \
  tst-ldbl-error \
  tst-ldbl-errorfptr \
  tst-ldbl-warn \
  tst-makedev \
  tst-mntent \
  tst-mntent-autofs \
  tst-mntent-blank-corrupt \
  tst-mntent-blank-passno \
  tst-mntent-escape \
  tst-mntent2 \
  tst-preadvwritev \
  tst-preadvwritev2 \
  tst-preadvwritev64 \
  tst-preadvwritev64v2 \
  tst-pselect \
  tst-select \
  tst-syscalls \
  tst-tsearch \
  tst-warn-wide \
  # tests

tests-time64 := \
  tst-ioctl-time64 \
  tst-pselect-time64 \
  tst-select-time64 \
  # tests-time64

# Tests which need libdl.
ifeq (yes,$(build-shared))
tests += tst-gethostid
endif

tests-internal := \
  tst-allocate_once \
  tst-atomic \
  tst-atomic-long \
  # tests-internal
tests-static := tst-empty

# Test for the internal, non-exported __fd_to_filename function.
tests-internal += tst-fd_to_filename
tests-static += tst-fd_to_filename

ifeq ($(run-built-tests),yes)
ifeq (yes,$(build-shared))
ifneq ($(PERL),no)
tests-special += \
  $(objpfx)tst-allocate_once-mem.out \
  $(objpfx)tst-error1-mem.out \
  # tests-special
endif
endif
endif

tests-container := \
  tst-syslog \
  tst-syslog-long-progname \
  # tests-container

CFLAGS-select.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-tsearch.c += $(uses-callbacks)
CFLAGS-lsearch.c += $(uses-callbacks)
CFLAGS-pselect.c += -fexceptions
CFLAGS-readv.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-writev.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-preadv.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-preadv64.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwritev.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwritev64.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-preadv2.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-preadv64v2.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwritev2.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwritev64v2.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-usleep.c += -fexceptions
CFLAGS-syslog.c += -fexceptions
CFLAGS-error.c += -fexceptions
CFLAGS-getpass.c += -fexceptions
CFLAGS-mkstemp.c += -fexceptions
CFLAGS-mkstemp64.c += -fexceptions
CFLAGS-getsysstats.c += -fexceptions
CFLAGS-getusershell.c += -fexceptions
CFLAGS-err.c += -fexceptions
CFLAGS-tst-tsearch.c += $(stack-align-test-flags)
CFLAGS-msync.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-fdatasync.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-fsync.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-makedev.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-mmap64.c += $(config-cflags-wno-ignored-attributes)

# Called during static library initialization, so turn stack-protection
# off for non-shared builds.
CFLAGS-sbrk.o = $(no-stack-protector)
CFLAGS-sbrk.op = $(no-stack-protector)
CFLAGS-brk.o = $(no-stack-protector)
CFLAGS-brk.op = $(no-stack-protector)
CFLAGS-mmap.o = $(no-stack-protector)
CFLAGS-mmap.op = $(no-stack-protector)
CFLAGS-mmap64.o = $(no-stack-protector)
CFLAGS-mmap64.op = $(no-stack-protector)

include ../Rules

$(objpfx)libg.a: $(dep-dummy-lib); $(make-dummy-lib)

$(objpfx)tst-tsearch: $(libm)

tst-error1-ENV = MALLOC_TRACE=$(objpfx)tst-error1.mtrace \
		 LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
tst-error1-ARGS = $(objpfx)tst-error1.out
$(objpfx)tst-error1-mem.out: $(objpfx)tst-error1.out
	$(common-objpfx)malloc/mtrace $(objpfx)tst-error1.mtrace > $@; \
	$(evaluate-test)

tst-allocate_once-ENV = MALLOC_TRACE=$(objpfx)tst-allocate_once.mtrace \
			LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
$(objpfx)tst-allocate_once-mem.out: $(objpfx)tst-allocate_once.out
	$(common-objpfx)malloc/mtrace $(objpfx)tst-allocate_once.mtrace > $@; \
	$(evaluate-test)

tst-syslog-long-progname-ENV = GLIBC_TUNABLES=glibc.malloc.check=3 \
			       LD_PRELOAD=libc_malloc_debug.so.0

$(objpfx)tst-select: $(librt)
$(objpfx)tst-select-time64: $(librt)
$(objpfx)tst-pselect: $(librt)
$(objpfx)tst-pselect-time64: $(librt)

=== signal/Makefile ===
# Copyright (C) 1991-2024 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Makefile for signal routines.
#
subdir	:= signal

include ../Makeconfig

headers := signal.h sys/signal.h \
	   bits/signum-generic.h bits/signum-arch.h \
	   bits/sigcontext.h bits/sigaction.h \
	   bits/sigevent-consts.h bits/siginfo-consts.h \
	   bits/sigstack.h bits/sigthread.h bits/ss_flags.h \
	   bits/types/__sigset_t.h bits/types/sig_atomic_t.h \
	   bits/types/sigevent_t.h bits/types/siginfo_t.h \
	   bits/types/sigset_t.h bits/types/sigval_t.h \
	   bits/types/stack_t.h bits/types/struct_sigstack.h \
	   bits/types/__sigval_t.h bits/signal_ext.h \
	   bits/sigstksz.h

routines	:= signal raise killpg \
		   sigaction libc_sigaction sigprocmask kill \
		   sigpending sigsuspend sigwait \
		   sigblock sigsetmask sigpause sigvec \
		   sigstack sigaltstack sigintr \
		   sigsetops sigempty sigfillset sigaddset sigdelset sigismem \
		   sigreturn \
		   siggetmask sysv_signal \
		   sigisempty sigandset sigorset \
		   allocrtsig sigtimedwait sigwaitinfo sigqueue \
		   sighold sigrelse sigignore sigset

tests := \
  tst-minsigstksz-1 \
  tst-minsigstksz-2 \
  tst-minsigstksz-3 \
  tst-minsigstksz-3a \
  tst-minsigstksz-4 \
  tst-minsigstksz-5 \
  tst-raise \
  tst-sigaction \
  tst-sigisemptyset \
  tst-signal \
  tst-sigset \
  tst-sigset2 \
  tst-sigsimple \
  tst-sigwait-eintr \
# tests

include ../Rules

CFLAGS-raise.c += -fasynchronous-unwind-tables
CFLAGS-sigpause.c += -fexceptions
CFLAGS-sigsuspend.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-sigtimedwait.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-sigwait.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-sigwaitinfo.c += -fexceptions -fasynchronous-unwind-tables

CFLAGS-sigreturn.c += $(no-stack-protector)

# We don't want to test the lazy resolution stack usage, just the
# execution of the handler and the functions.
LDFLAGS-tst-minsigstksz-1 = -Wl,-z,now
LDFLAGS-tst-minsigstksz-2 = -Wl,-z,now
LDFLAGS-tst-minsigstksz-3 = -Wl,-z,now
LDFLAGS-tst-minsigstksz-3a = -Wl,-z,now
LDFLAGS-tst-minsigstksz-4 = -Wl,-z,now

=== stdlib/Makefile ===
# Copyright (C) 1991-2024 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Makefile for stdlib routines
#
subdir	:= stdlib

include ../Makeconfig

headers := \
  alloca.h \
  bits/errno.h \
  bits/indirect-return.h \
  bits/monetary-ldbl.h \
  bits/stdint-intn.h \
  bits/stdint-least.h \
  bits/stdint-uintn.h \
  bits/stdlib-bsearch.h \
  bits/stdlib-float.h \
  bits/stdlib-ldbl.h \
  bits/stdlib.h \
  bits/time64.h \
  bits/timesize.h \
  bits/types/error_t.h \
  bits/wordsize.h \
  errno.h \
  fmtmsg.h \
  inttypes.h \
  monetary.h \
  stdbit.h \
  stdint.h \
  stdlib.h \
  sys/errno.h \
  sys/random.h \
  sys/ucontext.h \
  ucontext.h \
  # headers

routines := \
  a64l \
  abort \
  abs \
  arc4random \
  arc4random_uniform \
  at_quick_exit \
  atof \
  atoi \
  atol\
  atoll \
  bsearch \
  canonicalize \
  cxa_at_quick_exit \
  cxa_atexit \
  cxa_finalize \
  cxa_thread_atexit_impl \
  div \
  drand48 \
  drand48-iter \
  drand48_r \
  erand48 \
  erand48_r \
  exit \
  fmtmsg \
  getcontext \
  getentropy \
  getenv \
  getrandom \
  getsubopt \
  jrand48 \
  jrand48_r \
  l64a \
  labs \
  lcong48 \
  lcong48_r \
  ldiv \
  llabs \
  lldiv \
  lrand48 \
  lrand48_r \
  makecontext \
  mblen \
  mbstowcs \
  mbtowc \
  mrand48 \
  mrand48_r \
  nrand48 \
  nrand48_r \
  old_atexit  \
  on_exit atexit \
  putenv \
  qsort \
  quick_exit \
  rand \
  rand_r \
  random \
  random_r \
  rpmatch \
  secure-getenv \
  seed48 \
  seed48_r \
  setcontext \
  setenv \
  srand48 \
  srand48_r \
  stdc_bit_ceil_uc \
  stdc_bit_ceil_ui \
  stdc_bit_ceil_ul \
  stdc_bit_ceil_ull \
  stdc_bit_ceil_us \
  stdc_bit_floor_uc \
  stdc_bit_floor_ui \
  stdc_bit_floor_ul \
  stdc_bit_floor_ull \
  stdc_bit_floor_us \
  stdc_bit_width_uc \
  stdc_bit_width_ui \
  stdc_bit_width_ul \
  stdc_bit_width_ull \
  stdc_bit_width_us \
  stdc_count_ones_uc \
  stdc_count_ones_ui \
  stdc_count_ones_ul \
  stdc_count_ones_ull \
  stdc_count_ones_us \
  stdc_count_zeros_uc \
  stdc_count_zeros_ui \
  stdc_count_zeros_ul \
  stdc_count_zeros_ull \
  stdc_count_zeros_us \
  stdc_first_leading_one_uc \
  stdc_first_leading_one_ui \
  stdc_first_leading_one_ul \
  stdc_first_leading_one_ull \
  stdc_first_leading_one_us \
  stdc_first_leading_zero_uc \
  stdc_first_leading_zero_ui \
  stdc_first_leading_zero_ul \
  stdc_first_leading_zero_ull \
  stdc_first_leading_zero_us \
  stdc_first_trailing_one_uc \
  stdc_first_trailing_one_ui \
  stdc_first_trailing_one_ul \
  stdc_first_trailing_one_ull \
  stdc_first_trailing_one_us \
  stdc_first_trailing_zero_uc \
  stdc_first_trailing_zero_ui \
  stdc_first_trailing_zero_ul \
  stdc_first_trailing_zero_ull \
  stdc_first_trailing_zero_us \
  stdc_has_single_bit_uc \
  stdc_has_single_bit_ui \
  stdc_has_single_bit_ul \
  stdc_has_single_bit_ull \
  stdc_has_single_bit_us \
  stdc_leading_ones_uc \
  stdc_leading_ones_ui \
  stdc_leading_ones_ul \
  stdc_leading_ones_ull \
  stdc_leading_ones_us \
  stdc_leading_zeros_uc \
  stdc_leading_zeros_ui \
  stdc_leading_zeros_ul \
  stdc_leading_zeros_ull \
  stdc_leading_zeros_us \
  stdc_trailing_ones_uc \
  stdc_trailing_ones_ui \
  stdc_trailing_ones_ul \
  stdc_trailing_ones_ull \
  stdc_trailing_ones_us \
  stdc_trailing_zeros_uc \
  stdc_trailing_zeros_ui \
  stdc_trailing_zeros_ul \
  stdc_trailing_zeros_ull \
  stdc_trailing_zeros_us \
  strfmon \
  strfmon_l \
  strfromd \
  strfromf \
  strfroml \
  strtod \
  strtod_l \
  strtod_nan \
  strtof \
  strtof_l \
  strtof_nan \
  strtol \
  strtol_l \
  strtold \
  strtold_l \
  strtold_nan \
  strtoll \
  strtoll_l \
  strtoul \
  strtoul_l \
  strtoull \
  strtoull_l \
  swapcontext \
  system \
  wcstombs \
  wctomb  \
  xpg_basename \
  # routines

# Exclude fortified routines from being built with _FORTIFY_SOURCE
routines_no_fortify += \
  mbstowcs \
  wcstombs \
  wctomb \
  # routines_no_fortify

aux = \
  grouping \
  groupingwc \
  tens_in_limb \
  # aux

# These routines will be omitted from the libc shared object.
# Instead the static object files will be included in a special archive
# linked against when the shared library will be used.
static-only-routines = \
  at_quick_exit \
  atexit \
  # static-only-routines

test-srcs := \
  tst-fmtmsg \
  #test-srcs

tests := \
  bug-fmtmsg1 \
  bug-getcontext \
  bug-strtod \
  bug-strtod2 \
  test-a64l \
  test-at_quick_exit-race \
  test-atexit-race \
  test-atexit-recursive \
  test-bz22786 \
  test-canon \
  test-canon2 \
  test-cxa_atexit-race \
  test-cxa_atexit-race2 \
  test-dlclose-exit-race \
  test-on_exit-race \
  testdiv \
  testmb \
  testmb2 \
  testrand \
  testsort \
  tst-abs \
  tst-arc4random-fork \
  tst-arc4random-stats \
  tst-arc4random-thread \
  tst-at_quick_exit \
  tst-atexit \
  tst-atof1 \
  tst-atof2 \
  tst-bsearch \
  tst-bz20544 \
  tst-canon-bz26341 \
  tst-cxa_atexit \
  tst-environ \
  tst-getrandom \
  tst-labs \
  tst-limits \
  tst-llabs \
  tst-makecontext \
  tst-makecontext-align \
  tst-makecontext2 \
  tst-makecontext3 \
  tst-on_exit \
  tst-qsort \
  tst-qsort2 \
  tst-qsort3 \
  tst-qsort6 \
  tst-quick_exit \
  tst-rand48 \
  tst-rand48-2 \
  tst-random \
  tst-random2 \
  tst-realpath \
  tst-realpath-toolong \
  tst-secure-getenv \
  tst-setcontext \
  tst-setcontext2 \
  tst-setcontext3 \
  tst-setcontext4 \
  tst-setcontext5 \
  tst-setcontext6 \
  tst-setcontext7 \
  tst-setcontext8 \
  tst-setcontext9 \
  tst-setcontext10 \
  tst-setcontext11 \
  tst-stdbit-Wconversion \
  tst-stdbit-builtins \
  tst-stdc_bit_ceil \
  tst-stdc_bit_floor \
  tst-stdc_bit_width \
  tst-stdc_count_ones \
  tst-stdc_count_zeros \
  tst-stdc_first_leading_one \
  tst-stdc_first_leading_zero \
  tst-stdc_first_trailing_one \
  tst-stdc_first_trailing_zero \
  tst-stdc_has_single_bit \
  tst-stdc_leading_ones \
  tst-stdc_leading_zeros \
  tst-stdc_trailing_ones \
  tst-stdc_trailing_zeros \
  tst-strfmon_l \
  tst-strfrom \
  tst-strfrom-locale \
  tst-strtod \
  tst-strtod-nan-locale \
  tst-strtod-nan-sign \
  tst-strtod-overflow \
  tst-strtod-round \
  tst-strtod-underflow \
  tst-strtod2 \
  tst-strtod5 \
  tst-strtod6 \
  tst-strtol \
  tst-strtol-binary-c11 \
  tst-strtol-binary-c23 \
  tst-strtol-binary-gnu11 \
  tst-strtol-binary-gnu23 \
  tst-strtol-locale \
  tst-strtoll \
  tst-swapcontext1 \
  tst-swapcontext2 \
  tst-thread-quick_exit \
  tst-tininess \
  tst-unsetenv1 \
  tst-width \
  tst-width-stdint \
  tst-xpg-basename \
  # tests

tests-internal := \
  tst-qsort4 \
  tst-strtod1i \
  tst-strtod3 \
  tst-strtod4 \
  tst-strtod5i \
  tst-tls-atexit \
  tst-tls-atexit-nodelete \
  # tests-internal

tests-static := \
  tst-secure-getenv \
  # tests-static

tests-container := \
  tst-system \
  #tests-container

ifeq ($(build-hardcoded-path-in-tests),yes)
tests += \
  tst-empty-env \
  # tests
endif

LDLIBS-test-atexit-race = $(shared-thread-library)
LDLIBS-test-at_quick_exit-race = $(shared-thread-library)
LDLIBS-test-cxa_atexit-race = $(shared-thread-library)
LDLIBS-test-cxa_atexit-race2 = $(shared-thread-library)
LDLIBS-test-on_exit-race = $(shared-thread-library)
LDLIBS-tst-canon-bz26341 = $(shared-thread-library)
LDLIBS-tst-arc4random-fork = $(shared-thread-library)
LDLIBS-tst-arc4random-thread = $(shared-thread-library)
LDLIBS-tst-system = $(shared-thread-library)

LDLIBS-test-dlclose-exit-race = $(shared-thread-library)
LDFLAGS-test-dlclose-exit-race = $(LDFLAGS-rdynamic)
LDLIBS-test-dlclose-exit-race-helper.so = $(libsupport) $(shared-thread-library)

CFLAGS-tst-abs.c += -fno-builtin
CFLAGS-tst-labs.c += -fno-builtin
CFLAGS-tst-llabs.c += -fno-builtin

CFLAGS-tst-stdbit-Wconversion.c += -Wconversion -Werror
CFLAGS-tst-stdc_trailing_zeros.c += -fno-builtin
CFLAGS-tst-stdc_trailing_ones.c += -fno-builtin
CFLAGS-tst-stdc_leading_zeros.c += -fno-builtin
CFLAGS-tst-stdc_leading_ones.c += -fno-builtin
CFLAGS-tst-stdc_has_single_bit.c += -fno-builtin
CFLAGS-tst-stdc_first_trailing_zero.c += -fno-builtin
CFLAGS-tst-stdc_first_trailing_one.c += -fno-builtin
CFLAGS-tst-stdc_first_leading_zero.c += -fno-builtin
CFLAGS-tst-stdc_first_leading_one.c += -fno-builtin
CFLAGS-tst-stdc_count_zeros.c += -fno-builtin
CFLAGS-tst-stdc_count_ones.c += -fno-builtin
CFLAGS-tst-stdc_bit_width.c += -fno-builtin
CFLAGS-tst-stdc_bit_floor.c += -fno-builtin
CFLAGS-tst-stdc_bit_ceil.c += -fno-builtin

ifeq ($(have-cxx-thread_local),yes)
CFLAGS-tst-quick_exit.o = -std=c++11
LDLIBS-tst-quick_exit = -lstdc++
CFLAGS-tst-thread-quick_exit.o = -std=c++11
LDLIBS-tst-thread-quick_exit = -lstdc++
$(objpfx)tst-thread-quick_exit: $(shared-thread-library)
else
tests-unsupported += \
  tst-quick_exit \
  tst-thread-quick_exit \
  # tests-unsupported
endif

modules-names = \
  test-dlclose-exit-race-helper \
  tst-tls-atexit-lib \
  # modules-names
extra-test-objs += $(addsuffix .os, $(modules-names))

ifeq ($(build-shared),yes)
tests += \
  tst-putenv \
  # tests
endif

# Several mpn functions from GNU MP are used by the strtod function.
mpn-routines := \
  add_n \
  addmul_1 \
  cmp \
  divmod_1 \
  divrem \
  inlines \
  lshift \
  mod_1 \
  mul \
  mul_1 \
  mul_n \
  rshift \
  sub_n \
  submul_1 \
  udiv_qrnnd \
  # mpn-routines
mpn-headers = \
  asm-syntax.h \
  gmp-impl.h \
  gmp-mparam.h \
  gmp.h \
  longlong.h \
  # mpn-headers

routines := \
  $(strip $(routines) $(mpn-routines)) \
  dbl2mpn \
  ldbl2mpn \
  mpn2dbl \
  mpn2flt \
  mpn2ldbl \
  # routines
aux += \
  fpioconst \
  mp_clz_tab \
  # aux

tests-extras += \
  tst-putenvmod \
  # tests-extras

extra-test-objs += \
  tst-putenvmod.os \
  # extra-test-objs

generated += \
  isomac \
  isomac.out \
  tst-putenvmod.so \
  # generated

CFLAGS-bsearch.c += $(uses-callbacks)
CFLAGS-qsort.c += $(uses-callbacks)
CFLAGS-system.c += -fexceptions
CFLAGS-system.os = -fomit-frame-pointer
CFLAGS-fmtmsg.c += -fexceptions

CFLAGS-strfmon.c += $(libio-mtsafe)
CFLAGS-strfmon_l.c += $(libio-mtsafe)

# The strfrom class of functions call __printf_fp in order to convert the
# floating-point value to characters.  This requires the value of IO_MTSAFE_IO.
CFLAGS-strfromd.c += $(libio-mtsafe)
CFLAGS-strfromf.c += $(libio-mtsafe)
CFLAGS-strfroml.c += $(libio-mtsafe)

CFLAGS-strtol.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-strtoul.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-strtoll.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-strtoull.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-strtof.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-strtof_l.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-strtod.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-strtod_l.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-strtold.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-strtold_l.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-secure-getenv.c += $(config-cflags-wno-ignored-attributes)

CFLAGS-tst-bsearch.c += $(stack-align-test-flags)
CFLAGS-tst-qsort.c += $(stack-align-test-flags)
CFLAGS-tst-makecontext.c += -funwind-tables
CFLAGS-tst-makecontext2.c += $(stack-align-test-flags)

CFLAGS-testmb.c += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 -Wall -Werror

# Some versions of GCC supported for building glibc do not support -std=c23
# or -std=gnu23 (added in GCC 14), or the older names -std=c2x or -std=gnu2x

=== sysvipc/Makefile ===
# Copyright (C) 1995-2024 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for sysvipc portion of the library.
#
subdir	:= sysvipc

include ../Makeconfig

headers	:= sys/ipc.h sys/msg.h sys/sem.h sys/shm.h \
	   bits/ipctypes.h bits/ipc.h bits/msq.h bits/sem.h bits/shm.h

routines := ftok \
	    msgsnd msgrcv msgget msgctl \
	    semop semget semctl semtimedop \
	    shmat shmdt shmget shmctl

tests    := test-sysvmsg test-sysvsem test-sysvshm

tests-time64 := test-sysvmsg-time64 test-sysvsem-time64 test-sysvshm-time64

include ../Rules

CFLAGS-msgrcv.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-msgsnd.c += -fexceptions -fasynchronous-unwind-tables

$(objpfx)test-sysvsem: $(librt)
$(objpfx)test-sysvsem-time64: $(librt)

=== time/Makefile ===
# Copyright (C) 1991-2024 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Makefile for time routines
#
subdir	:= time

include ../Makeconfig

headers := time.h sys/time.h sys/timeb.h bits/time.h			\
	   bits/types/clockid_t.h bits/types/clock_t.h			\
	   bits/types/struct_itimerspec.h				\
	   bits/types/struct_timespec.h bits/types/struct_timeval.h	\
	   bits/types/struct_tm.h bits/types/timer_t.h			\
	   bits/types/time_t.h bits/types/struct_timeb.h

routines := offtime asctime clock ctime ctime_r difftime \
	    gmtime localtime mktime time		 \
	    gettimeofday settimeofday settimezone	 \
	    adjtime tzset tzfile getitimer setitimer	 \
	    stime dysize timegm ftime			 \
	    getdate strptime strptime_l			 \
	    strftime wcsftime strftime_l wcsftime_l	 \
	    timespec_get timespec_getres		 \
	    clock_getcpuclockid clock_getres		 \
	    clock_gettime clock_settime clock_nanosleep

aux :=	    era alt_digit lc-time-cleanup

tests := \
  bug-asctime \
  bug-asctime_r \
  bug-getdate1 \
  bug-mktime1 \
  bug-mktime4 \
  clocktest \
  test_time \
  tst-adjtime \
  tst-clock \
  tst-clock2 \
  tst-clock_nanosleep \
  tst-clock_settime \
  tst-cpuclock1 \
  tst-ctime \
  tst-difftime \
  tst-ftime \
  tst-ftime_l \
  tst-getdate \
  tst-gmtime \
  tst-itimer \
  tst-mktime \
  tst-mktime2 \
  tst-mktime3 \
  tst-mktime4 \
  tst-posixtz \
  tst-settimeofday \
  tst-strftime \
  tst-strftime2 \
  tst-strftime3 \
  tst-strftime4 \
  tst-strptime \
  tst-strptime-whitespace \
  tst-strptime2 \
  tst-strptime3 \
  tst-timegm \
  tst-timespec_get \
  tst-timespec_getres \
  tst-tzfile-fault \
  tst-tzname \
  tst-y2039 \
  tst_wcsftime \
  # tests

tests-time64 := \
  tst-adjtime-time64 \
  tst-clock-time64 \
  tst-clock2-time64 \
  tst-clock_nanosleep-time64 \
  tst-clock_settime-time64 \
  tst-cpuclock1-time64 \
  tst-ctime-time64 \
  tst-difftime-time64 \
  tst-gmtime-time64 \
  tst-itimer-time64 \
  tst-mktime4-time64 \
  tst-settimeofday-time64 \
  tst-strftime4-time64 \
  tst-timegm-time64 \
  tst-timespec_get-time64 \
  tst-timespec_getres-time64 \
  tst-y2039-time64

include ../Rules

ifeq ($(run-built-tests),yes)
LOCALES := de_DE.ISO-8859-1 en_US.ISO-8859-1 ja_JP.EUC-JP fr_FR.UTF-8 \
	   es_ES.UTF-8 pl_PL.UTF-8 ru_RU.UTF-8 \
	   ja_JP.UTF-8 lo_LA.UTF-8 th_TH.UTF-8 \
	   zh_TW.UTF-8 cmn_TW.UTF-8 hak_TW.UTF-8 \
	   nan_TW.UTF-8 lzh_TW.UTF-8
include ../gen-locales.mk

$(objpfx)tst-ftime_l.out: $(gen-locales)
$(objpfx)tst-strptime.out: $(gen-locales)
$(objpfx)tst-strftime2.out: $(gen-locales)
$(objpfx)tst-strftime3.out: $(gen-locales)
endif

$(objpfx)tst-clock_nanosleep: $(librt)
$(objpfx)tst-clock_nanosleep-time64: $(librt)

tz-cflags = -DTZDIR='"$(zonedir)"' \
	    -DTZDEFAULT='"$(localtime-file)"' \
	    -DTZDEFRULES='"$(posixrules-file)"'

CFLAGS-tzfile.c += $(tz-cflags)
CFLAGS-tzset.c += $(tz-cflags)
CFLAGS-getdate.c += -fexceptions
CFLAGS-clock_nanosleep.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-nanosleep.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-mktime.c += $(config-cflags-wno-ignored-attributes)

# Don't warn about Y2k problem in strftime format string.
CFLAGS-test_time.c += -Wno-format

test_time-ARGS= EST5EDT CST

tst-tzname-ENV = TZDIR=${common-objpfx}timezone/testdata
CPPFLAGS-tst-tzname.c += -DTZDEFRULES='"$(posixrules-file)"'

bug-getdate1-ARGS = ${objpfx}bug-getdate1-fmt

tst-tzfile-fault-ENV = GLIBC_TUNABLES=glibc.rtld.enable_secure=1

=== wcsmbs/Makefile ===
# Copyright (C) 1995-2024 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for wcsmbs portion of the library.
#
subdir	:= wcsmbs

include ../Makeconfig

headers := \
  bits/types/__mbstate_t.h \
  bits/types/mbstate_t.h \
  bits/types/wint_t.h \
  bits/wchar-ldbl.h \
  bits/wchar.h \
  bits/wchar2-decl.h \
  bits/wchar2.h \
  uchar.h \
  wchar.h \
  # headers

routines := \
  btowc \
  c16rtomb \
  c32rtomb \
  c8rtomb \
  isoc23_fwscanf \
  isoc23_swscanf \
  isoc23_vfwscanf \
  isoc23_vswscanf \
  isoc23_vwscanf \
  isoc23_wscanf \
  isoc99_fwscanf \
  isoc99_swscanf \
  isoc99_vfwscanf \
  isoc99_vswscanf \
  isoc99_vwscanf \
  isoc99_wscanf \
  mbrlen \
  mbrtoc8 \
  mbrtoc16 \
  mbrtoc32 \
  mbrtowc \
  mbsinit \
  mbsnrtowcs \
  mbsrtowcs \
  mbsrtowcs_l \
  wcpcpy \
  wcpncpy \
  wcrtomb \
  wcscasecmp \
  wcscasecmp_l \
  wcscat \
  wcschr \
  wcschrnul \
  wcscmp \
  wcscoll \
  wcscoll_l \
  wcscpy \
  wcscspn \
  wcsdup \
  wcslcat \
  wcslcpy \
  wcslen \
  wcsmbsload \
  wcsncase \
  wcsncase_l \
  wcsncat \
  wcsncmp \
  wcsncpy \
  wcsnlen \
  wcsnrtombs \
  wcspbrk \
  wcsrchr \
  wcsrtombs \
  wcsspn \
  wcsstr \
  wcstod \
  wcstod_l \
  wcstod_nan \
  wcstof \
  wcstof_l \
  wcstof_nan \
  wcstok \
  wcstol \
  wcstol_l \
  wcstold \
  wcstold_l \
  wcstold_nan \
  wcstoll \
  wcstoll_l \
  wcstoul \
  wcstoul_l \
  wcstoull \
  wcstoull_l \
  wcswidth \
  wcsxfrm \
  wcsxfrm_l \
  wctob \
  wcwidth \
  wmemchr \
  wmemcmp \
  wmemcpy \
  wmemmove \
  wmempcpy \
  wmemset \
  # routines

# Exclude fortified routines from being built with _FORTIFY_SOURCE
routines_no_fortify += \
  mbsnrtowcs \
  mbsrtowcs \
  wcpcpy \
  wcpncpy \
  wcrtomb \
  wcscat \
  wcscpy \
  wcslcat \
  wcslcpy \
  wcsncat \
  wcsncpy \
  wcsnrtombs \
  wcsrtombs \
  wmemcpy \
  wmemmove \
  wmempcpy \
  wmemset \
  # routines_no_fortify

tests := \
  test-c8rtomb \
  test-char-types \
  test-mbrtoc8 \
  test-wcpcpy \
  test-wcpncpy \
  test-wcscat \
  test-wcschr \
  test-wcschrnul \
  test-wcscmp \
  test-wcscpy \
  test-wcscspn \
  test-wcsdup \
  test-wcslen \
  test-wcsncat \
  test-wcsncmp \
  test-wcsncpy \
  test-wcsnlen \
  test-wcspbrk \
  test-wcsrchr \
  test-wcsspn \
  test-wcsstr \
  test-wmemchr \
  test-wmemcmp \
  test-wmemset \
  tst-btowc \
  tst-c16-surrogate \
  tst-c16c32-1 \
  tst-c32-state \
  tst-fgetwc-after-eof \
  tst-mbrtowc \
  tst-mbrtowc2 \
  tst-mbsrtowcs \
  tst-mbstowcs \
  tst-wchar-h \
  tst-wcpncpy \
  tst-wcrtomb \
  tst-wcslcat \
  tst-wcslcat2 \
  tst-wcslcpy \
  tst-wcslcpy2 \
  tst-wcsnlen \
  tst-wcstod-nan-locale \
  tst-wcstod-nan-sign \
  tst-wcstod-round \
  tst-wcstof \
  tst-wcstol-binary-c11 \
  tst-wcstol-binary-c23 \
  tst-wcstol-binary-gnu11 \
  tst-wcstol-binary-gnu23 \
  tst-wcstol-locale \
  tst-wprintf-binary \
  tst-wprintf-intn \
  tst-wscanf-binary-c11 \
  tst-wscanf-binary-c23 \
  tst-wscanf-binary-gnu11 \
  tst-wscanf-binary-gnu89 \
  tst-wscanf-intn \
  tst-wscanf-to_inpunct \
  wcsatcliff \
  wcsmbs-tst1 \
  # tests

include ../Rules

ifeq ($(run-built-tests),yes)
LOCALES := \
  de_DE.ISO-8859-1 \
  de_DE.UTF-8 \
  en_US.ANSI_X3.4-1968 \
  fa_IR.UTF-8 \
  hr_HR.ISO-8859-2 \
  ja_JP.EUC-JP \
  tr_TR.ISO-8859-9 \
  tr_TR.UTF-8 \
  zh_HK.BIG5-HKSCS \
  zh_TW.EUC-TW \
  # LOCALES
include ../gen-locales.mk

$(objpfx)tst-btowc.out: $(gen-locales)
$(objpfx)tst-c16c32-1.out: $(gen-locales)
$(objpfx)tst-mbrtowc.out: $(gen-locales)
$(objpfx)tst-mbrtowc2.out: $(gen-locales)
$(objpfx)tst-wcrtomb.out: $(gen-locales)
$(objpfx)wcsmbs-tst1.out: $(gen-locales)
$(objpfx)tst-wcstol-locale.out: $(gen-locales)
$(objpfx)tst-wcstod-nan-locale.out: $(gen-locales)
$(objpfx)tst-c16-surrogate.out: $(gen-locales)
$(objpfx)tst-c32-state.out: $(gen-locales)
$(objpfx)test-c8rtomb.out: $(gen-locales)
$(objpfx)test-mbrtoc8.out: $(gen-locales)
$(objpfx)tst-wscanf-to_inpunct.out: $(gen-locales)
endif

$(objpfx)tst-wcstod-round: $(libm)

CFLAGS-wcwidth.c += -I../wctype
CFLAGS-wcswidth.c += -I../wctype

strtox-CFLAGS = -I../include
CFLAGS-wcstol.c += $(strtox-CFLAGS) $(config-cflags-wno-ignored-attributes)
CFLAGS-wcstoul.c += $(strtox-CFLAGS) $(config-cflags-wno-ignored-attributes)
CFLAGS-wcstoll.c += $(strtox-CFLAGS)
CFLAGS-wcstoull.c += $(strtox-CFLAGS)
CFLAGS-wcstod.c += $(strtox-CFLAGS) $(config-cflags-wno-ignored-attributes)
CFLAGS-wcstold.c += $(strtox-CFLAGS) $(config-cflags-wno-ignored-attributes)
CFLAGS-wcstof128.c += $(strtox-CFLAGS)
CFLAGS-wcstof.c += $(strtox-CFLAGS) $(config-cflags-wno-ignored-attributes)
CFLAGS-wcstol_l.c += $(strtox-CFLAGS)
CFLAGS-wcstoul_l.c += $(strtox-CFLAGS)
CFLAGS-wcstoll_l.c += $(strtox-CFLAGS)
CFLAGS-wcstoull_l.c += $(strtox-CFLAGS)
CFLAGS-wcstod_l.c += $(strtox-CFLAGS) $(config-cflags-wno-ignored-attributes)
CFLAGS-wcstold_l.c += $(strtox-CFLAGS) $(config-cflags-wno-ignored-attributes)
CFLAGS-wcstof128_l.c += $(strtox-CFLAGS)
CFLAGS-wcstof_l.c += $(strtox-CFLAGS) $(config-cflags-wno-ignored-attributes)
CPPFLAGS-tst-wchar-h.c += $(no-fortify-source),-D_FORTIFY_SOURCE=2

CFLAGS-wcschr.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-wmemchr.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-wmemset.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-mbrtowc.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-wcrtomb.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-wcstoll.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-wcstoull.c += $(config-cflags-wno-ignored-attributes)

CFLAGS-isoc99_wscanf.c += -fexceptions
CFLAGS-isoc99_fwscanf.c += -fexceptions
CFLAGS-isoc99_vwscanf.c += -fexceptions
CFLAGS-isoc99_vfwscanf.c += -fexceptions
CFLAGS-isoc23_wscanf.c += -fexceptions
CFLAGS-isoc23_fwscanf.c += -fexceptions
CFLAGS-isoc23_vwscanf.c += -fexceptions
CFLAGS-isoc23_vfwscanf.c += -fexceptions

CPPFLAGS += $(libio-mtsafe)

# We need to find the default version of strtold_l in stdlib.
CPPFLAGS-wcstold_l.c += -I../stdlib

$(objpfx)tst-wcstod-nan-locale: $(libm)
$(objpfx)tst-wcstod-nan-sign: $(libm)

# Some versions of GCC supported for building glibc do not support -std=c23
# or -std=gnu23 (added in GCC 14), or the older names -std=c2x or -std=gnu2x
# (added in GCC 9), so the tests for those versions use -std=c11 and -std=gnu11
# and then _ISOC23_SOURCE is defined in the test as needed.
CFLAGS-tst-wcstol-binary-c11.c += -std=c11
CFLAGS-tst-wcstol-binary-c23.c += -std=c11
CFLAGS-tst-wcstol-binary-gnu11.c += -std=gnu11
CFLAGS-tst-wcstol-binary-gnu23.c += -std=gnu11
CFLAGS-tst-wscanf-binary-c11.c += -std=c11 -DOBJPFX=\"$(objpfx)\"
CFLAGS-tst-wscanf-binary-c23.c += -std=c11 -DOBJPFX=\"$(objpfx)\"
CFLAGS-tst-wscanf-binary-gnu11.c += -std=gnu11 -DOBJPFX=\"$(objpfx)\"
CFLAGS-tst-wscanf-binary-gnu89.c += -std=gnu89 -DOBJPFX=\"$(objpfx)\"

=== sysdeps/aarch64/Makefile ===
long-double-fcts = yes

ifeq (yes,$(aarch64-bti))
# Mark linker output BTI compatible, it warns on non-BTI inputs.
sysdep-LDFLAGS += -Wl,-z,force-bti
# Make warnings fatal outside the test system.
LDFLAGS-lib.so += -Wl,--fatal-warnings
LDFLAGS-rtld += -Wl,-z,force-bti,--fatal-warnings
endif

ifeq ($(subdir),elf)
sysdep-dl-routines += dl-bti

tests += tst-audit26 \
	 tst-audit27

modules-names += \
    tst-audit26mod \
    tst-auditmod26 \
    tst-audit27mod \
    tst-auditmod27

$(objpfx)tst-audit26: $(objpfx)tst-audit26mod.so \
		      $(objpfx)tst-auditmod26.so
LDFLAGS-tst-audit26 += -Wl,-z,lazy
tst-audit26-ENV = LD_AUDIT=$(objpfx)tst-auditmod26.so

$(objpfx)tst-audit27: $(objpfx)tst-audit27mod.so \
		      $(objpfx)tst-auditmod27.so
$(objpfx)tst-audit27mod.so: $(libsupport)
LDFLAGS-tst-audit27 += -Wl,-z,lazy
tst-audit27-ENV = LD_AUDIT=$(objpfx)tst-auditmod27.so
endif

ifeq ($(subdir),elf)
sysdep-rtld-routines += dl-start
sysdep-dl-routines += tlsdesc dl-tlsdesc
gen-as-const-headers += dl-link.sym

tests-internal += tst-ifunc-arg-1 tst-ifunc-arg-2

ifeq (yes,$(aarch64-variant-pcs))
tests += tst-vpcs
modules-names += tst-vpcs-mod
LDFLAGS-tst-vpcs-mod.so = -Wl,-z,lazy
$(objpfx)tst-vpcs: $(objpfx)tst-vpcs-mod.so
endif
endif

ifeq ($(subdir),csu)
gen-as-const-headers += \
  tlsdesc.sym \
  rtld-global-offsets.sym
endif

ifeq ($(subdir),gmon)
CFLAGS-mcount.c += -mgeneral-regs-only
endif

ifeq ($(subdir),math)
CPPFLAGS += -I../soft-fp
CFLAGS-feupdateenv.c += $(config-cflags-wno-ignored-attributes)
endif

ifeq ($(subdir),misc)
sysdep_headers += sys/ifunc.h
sysdep_routines += \
  __mtag_tag_zero_region \
  __mtag_tag_region \
  __arm_za_disable

tests += \
  tst-sme-jmp
endif

ifeq ($(subdir),malloc)
sysdep_malloc_debug_routines = __mtag_tag_zero_region __mtag_tag_region
endif

=== sysdeps/arm/Makefile ===
gnulib-arch = $(elf-objpfx)libgcc-stubs.a
static-gnulib-arch = $(elf-objpfx)libgcc-stubs.a

ifeq ($(subdir),elf)
sysdep-dl-routines += tlsdesc dl-tlsdesc
sysdep_routines += aeabi_unwind_cpp_pr1 find_exidx
sysdep-rtld-routines += aeabi_unwind_cpp_pr1
shared-only-routines += aeabi_unwind_cpp_pr1

$(objpfx)libgcc-stubs.a: $(objpfx)aeabi_unwind_cpp_pr1.os
	$(build-extra-lib)

lib-noranlib: $(objpfx)libgcc-stubs.a

ifeq ($(build-shared),yes)
ifneq (no,$(have-mtls-descriptor))
tests += tst-armtlsdescloc tst-armtlsdescextnow tst-armtlsdescextlazy
modules-names += tst-armtlsdesclocmod
modules-names += tst-armtlsdescextlazymod tst-armtlsdescextnowmod
CPPFLAGS-tst-armtlsdescextnowmod.c += -Dstatic=
CPPFLAGS-tst-armtlsdescextlazymod.c += -Dstatic=
CFLAGS-tst-armtlsdesclocmod.c += -mtls-dialect=$(have-mtls-descriptor)
CFLAGS-tst-armtlsdescextnowmod.c += -mtls-dialect=$(have-mtls-descriptor)
CFLAGS-tst-armtlsdescextlazymod.c += -mtls-dialect=$(have-mtls-descriptor)
LDFLAGS-tst-armtlsdescextnowmod.so += -Wl,-z,now
tst-armtlsdescloc-ENV = LD_BIND_NOW=1
tst-armtlsdescextnow-ENV = LD_BIND_NOW=1
tst-armtlsdescextlazy-ENV = LD_BIND_NOW=1
$(objpfx)tst-armtlsdescloc: $(objpfx)tst-armtlsdesclocmod.so
$(objpfx)tst-armtlsdescextnow: $(objpfx)tst-armtlsdescextnowmod.so
$(objpfx)tst-armtlsdescextlazy: $(objpfx)tst-armtlsdescextlazymod.so
endif
endif
endif

ifeq ($(subdir),csu)
# get offset to rtld_global._dl_hwcap
gen-as-const-headers += rtld-global-offsets.sym tlsdesc.sym
aeabi_constants = aeabi_lcsts aeabi_sighandlers aeabi_math
aeabi_routines = aeabi_assert aeabi_localeconv aeabi_errno_addr \
		 aeabi_mb_cur_max aeabi_atexit aeabi_memclr aeabi_memcpy \
		 aeabi_memmove aeabi_memset \
		 aeabi_read_tp libc-aeabi_read_tp

sysdep_routines += $(aeabi_constants) $(aeabi_routines)
static-only-routines += $(aeabi_constants) aeabi_read_tp
shared-only-routines += libc-aeabi_read_tp

sysdep_routines += arm-unwind-resume
shared-only-routines += arm-unwind-resume
endif

ifeq ($(subdir),gmon)
sysdep_routines += arm-mcount
endif

ifeq ($(subdir),math)
CFLAGS-feupdateenv.c += $(config-cflags-wno-ignored-attributes)
endif

ifeq ($(subdir),rt)
librt-sysdep_routines += rt-aeabi_unwind_cpp_pr1 rt-arm-unwind-resume
librt-shared-only-routines += rt-aeabi_unwind_cpp_pr1 rt-arm-unwind-resume
endif

=== debian/changelog ===
glibc (2.40-5) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-MAP_NORESERVE.diff: Add MAP_NORESERVE flag.
  * debian/patches/hurd-i386/git-signal-reply-port.diff: Fix hurd build
    against gcc 14.

  [ Bjarni Ingi Gislason ]
  * debian/local/manpages/update-locale.8: fix issues reported by troff.
    Closes: #1088003.

  [ Aurelien Jarno ]
  * debian/patches/any/git-iconv-do-not-report-*.patch: backport iconv return
    code with transliteration fix from upstream.  Closes: #1087670.
  * debian/debhelper.in/locales.templates: add a note to clarify that the C,
    C.UTF-8 and POSIX locales do not need to be generated.  Closes: #1091473.
  * debian/patches/git-updates.diff: update from upstream stable branch.
  * patches/any/git-posix-fix-system-when-a-child-cannot-be-created-BZ-3.patch:
    backport patch from upstream to fix return value of system() when a child
    process cannot be created.  Closes: #1088964.
  * debian/rules.d/debhelper.mk: explicitly pass the library path to
    dh_shlibdeps for multilib packages, to fix a FTBFS with rebootstrap which
    does not install the g++-XX-multilib build-dependency.  Closes: #1088166.

  [ Carles Pina i Estany ]
  * Update Catalan debconf translation.  Closes: #1091705.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 03 Jan 2025 11:56:38 +0100

glibc (2.40-4) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: Update hurd xfails.
  * debian/patches/hurd-i386/git-default_pager.h.diff: Ship
    mach/default_pager.h again.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix memory corruption with ancient i386 binaries using stdio. Closes:
      #1080244.
    - Fix FTBFS with gcc-14 on hppa.  Closes: #1084052.
    - Drop debian/patches/sparc/submitted-sparc-clone.diff (merged).
  * debian/patches/arm/git-hwcap2-constants.diff: backport for upstream to
    support HWCAP2 values on arm32.  Closes: #1086502.
  * debian/control: add Recommends: libc-dev (= ${binary:Version}) to
    libc-devtools.  Closes: #1087881.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 23 Nov 2024 14:57:03 +0100

glibc (2.40-3) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: Avoid tests overflowing memory.
  * debian/testsuite-xfail-debian.mk: Update hurd xfails.

  [ Aurelien Jarno ]
  * debian/rules: build with gcc-14.
  * debian/control.in/main: adjust g++-for-host version on arm64 to ensure
    PAC/BTI support.
  * debian/patches/git-updates.diff: update from upstream stable branch.
  * debian/patches/any/git-iconv-*: backport iconv fixes and improvement from
    upstream master.  Closes: #328303, #1000652.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 24 Sep 2024 21:46:16 +0200

glibc (2.40-2) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/debhelper.in/libc-dev.install.hurd-amd64: Add missing libm-2.39.a.
  * debian/patches/hurd-i386/git-tst-aligned-alloc-random-thread{,-mcheck}.diff:
    Link threading tests with $(shared-thread-library).
  * debian/testsuite-xfail-debian.mk: Avoid tests overflowing memory.
  * debian/testsuite-xfail-debian.mk: Update hurd xfails.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 25 Aug 2024 20:16:17 +0200

glibc (2.40-1) experimental; urgency=medium

  [ Aurelien Jarno ]
  * New upstream release.
    - debian/symbols.wildcards: add 2.40.
    - debian/patches/hurd-i386/git-context.diff: upstreamed.
    - debian/patches/hurd-i386/git-xattr.diff: upstreamed.
    - debian/patches/hurd-i386/git-proc_getchildren_rusage.diff: upstreamed.
    - debian/patches/hurd-i386/git-AT_NO_AUTOMOUNT.diff: upstreamed.
    - debian/patches/hurd-i386/git-intr-msg-clobber.diff: upstreamed.
    - debian/patches/hurd-i386/git-pthread_self.diff: upstreamed.
    - debian/patches/hurd-i386/git-pthread_self.2.diff: upstreamed.
    - debian/patches/hurd-i386/tg-sysvshm.diff: rebased.
    - debian/patches/hurd-i386/tg-sendmsg-SCM_CREDS.diff: rebased.
    - debian/patches/hurd-i386/local-exec_filename.diff: rebased.
    - debian/patches/all/local-remove-manual.diff: refreshed.
    - debian/patches/any/local-cross.patch: refreshed.
    - debian/patches/any/git-test-epoll.diff: upstreamed.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 22 Jul 2024 07:14:59 +0200

glibc (2.39-7) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-fault-64bit.diff: Fix receiving exceptions.
  * debian/patches/hurd-i386/{tg-sendmsg-SCM_CREDS.diff,tg-ifaddrs_v6.diff}:
    Fix build with gcc-14.
  * debian/sysdeps/hurd-amd64.mk: Enable mvec.
  * debian/libc0.3.symbols.hurd-amd64: Add symbols for libmvec.
  * debian/patches/hurd-i386/git-pthread_symbols.diff: Fix missing symbols.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix build with libaudit 4.0.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 14 Aug 2024 16:06:39 +0200

glibc (2.39-6) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fixes elf/check-localplt test on power* with recent binutils.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 23 Jul 2024 19:09:58 +0200

glibc (2.39-5) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-pthread_self{,.2}.diff: Fix pthread_self()
    without libpthread.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fixes stdlib/tst-swapcontext2 test on hppa.  Closes: #1076512.
  * debian/rules.d/tarball.mk: remove useless code.
  * debian/sysdeps/arm64.mk: compile with -mbranch-protection=standard on
    arm64 to enable PAC/BTI support.  Closes: #1063515.
  * debian/control.in/main: build-depends on g++13-for-host (>= 13.3.0-3) on
    arm64 to ensure PAC/BTI support in GCC.



=== debian/control ===
Source: glibc
Section: libs
Priority: required
Build-Depends: gettext, dpkg (>= 1.18.7), dpkg-dev (>= 1.17.14), xz-utils, file, quilt,
 autoconf, gawk, debhelper-compat (= 13), rdfind, symlinks, netbase, gperf, bison,
 linux-libc-dev (>= 3.9) [linux-any],
 libaudit-dev [linux-any], libcap-dev [linux-any] <!stage2>, libselinux1-dev [linux-any] <!stage2>,
 mig-for-host (>= 1.8+git20200618-7~) [hurd-any], gnumach-dev (>= 2:1.8+git20200710-2~) [hurd-any],
 hurd-dev (>= 1:0.9.git20201127-4~) [hurd-any] | hurd-headers-dev [hurd-any],
 binutils-for-host (>= 2.38),
 g++-14-for-host, g++-14-multilib [amd64 i386 mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el powerpc ppc64 s390x sparc sparc64 x32] <!nobiarch>,
 g++-14-for-host (>= 14.1.0-4) [arm64],
 python3:native,
 libidn2-0 (>= 2.0.5~) <!nocheck>,
 libc-bin (>= 2.40) <cross>,
 libgd-dev <!stage1 !stage2>,
Build-Depends-Indep: perl, po-debconf (>= 1.0)
Rules-Requires-Root: no
Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
Uploaders: Clint Adams <clint@debian.org>, Aurelien Jarno <aurel32@debian.org>, Samuel Thibault <sthibault@debian.org>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/glibc-team/glibc
Vcs-Git: https://salsa.debian.org/glibc-team/glibc.git
Homepage: https://www.gnu.org/software/libc/libc.html

Package: libc-bin
Architecture: any
Section: libs
Priority: required
Essential: yes
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: dh-lua (<< 27+nmu1~)
Recommends: manpages
Build-Profiles: <!stage1>
Description: GNU C Library: Binaries
 This package contains utility programs related to the GNU C Library.
 .
  * getconf: query system configuration variables
  * getent: get entries from administrative databases
  * iconv, iconvconfig: convert between character encodings
  * ldd, ldconfig: print/configure shared library dependencies
  * locale, localedef: show/generate locale definitions
  * tzselect, zdump, zic: select/dump/compile time zones

Package: libc-dev-bin
Architecture: any
Section: libdevel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: manpages, manpages-dev
Suggests: libc-devtools (>> 2.40)
Build-Profiles: <!stage1>
Description: GNU C Library: Development binaries
 This package contains utility programs related to the GNU C Library
 development package.
 .
  * gencat: generate message catalogs

Package: libc-devtools
Architecture: any
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libc-dev-bin (<< 2.31-8)
Replaces: libc-dev-bin (<< 2.31-8)
Recommends: libc-dev (= ${binary:Version}), manpages, manpages-dev
Build-Profiles: <!stage1> <!stage2>
Description: GNU C Library: Development tools
 This package contains development tools shipped by the GNU C
 Library.
 .
  * memusage, memusagestat: profile a program's memory usage
  * mtrace: interpret the malloc trace log
  * sotruss: trace shared library calls
  * sprof: display shared object profiling data

Package: libc-l10n
Architecture: all
Section: localization
Priority: standard
Multi-Arch: foreign
Depends: ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: localization files
 This package contains the translation files for the GNU C library and
 utility programs.

Package: glibc-doc
Architecture: all
Section: doc
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: glibc-doc-reference
Build-Profiles: <!stage1>
Description: GNU C Library: Documentation
 Contains the complete GNU C Library ChangeLog.  The GNU C Library Reference
 manual has been moved into glibc-doc-reference for licensing reasons.

Package: glibc-source
Architecture: all
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: xz-utils
Build-Profiles: <!stage1>
Description: GNU C Library: sources
 This package contains the sources and patches which are needed to
 build glibc.

Package: locales
Architecture: all
Section: localization
Priority: standard
Depends: libc-bin (>> 2.40), libc-l10n (>> 2.40), ${misc:Depends}, debconf | debconf-2.0
Build-Profiles: <!stage1>
Description: GNU C Library: National Language (locale) data [support]
 Machine-readable data files, shared objects and programs used by the
 C library for localization (l10n) and internationalization (i18n) support.
 .
 This package contains tools to generate locale definitions from source
 files (included in this package). It allows you to customize which
 definitions actually get generated. This is a space-saver over how this
 package used to be, with all locales generated by default. This created
 a package that unpacked to an excess of 30 megs.

Package: locales-all
Architecture: any
Section: localization
Priority: optional
Multi-Arch: foreign
Depends: libc-l10n (>> 2.40), ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Precompiled locale data
 This package contains the precompiled locale data for all supported locales.
 A better alternative is to install the locales package and only select
 desired locales, but it can be useful on a low-memory machine because some
 locale files take a lot of memory to be compiled.

Package: nscd
Architecture: any
Section: admin
Multi-Arch: foreign
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Name Service Cache Daemon
 A daemon which handles passwd, group and host lookups
 for running programs and caches the results for the next
 query. You should install this package only if you use
 slow services like LDAP, NIS or NIS+.

Package: libc6
Architecture: amd64 arc arm64 armel armhf hppa i386 loong64 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: libs
Priority: optional
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}
Recommends: libidn2-0 (>= 2.0.5~)
Suggests: glibc-doc, debconf | debconf-2.0, libc-l10n, locales [!hurd-any], libnss-nis, libnss-nisplus
Provides: libc6-sparcv9b [sparc sparc64], libc0.3-i686 [hurd-i386], libc6-i686 [i386]
Conflicts: libc6-i686 [i386], libc6.1-alphaev67 [alpha]
Breaks: nscd (<< 2.40), locales (<< 2.40), locales-all (<< 2.40), gnumach-image-1.8-486 (<< 2:1.8+git20210923~), gnumach-image-1.8-486-dbg (<< 2:1.8+git20210923~), gnumach-image-1.8-xen-486 (<< 2:1.8+git20210923~), gnumach-image-1.8-xen-486-dbg (<< 2:1.8+git20210923~), hurd (<< 1:0.9.git20220301-2), python3-iptables (<< 1.0.0-2), fakechroot (<< 2.19-3.5), tinydns (<< 1:1.05-14), chrony (<< 4.2-3~), valgrind (<< 1:3.19.0-1~), firefox (<< 91~), firefox-esr (<< 91~), systemd (<< 256~rc4-1~), sysvinit (<< 3.09-2~), base-files (<< 13.3~)
Replaces: libc6-amd64 [amd64],
          libc6-i386 [i386],
          libc0.3-i686 [hurd-i386],
          libc6-i686 [i386],
          libc6-x32 [x32],
          libc6-powerpc [powerpc],
          libc6-ppc64 [ppc64],
          libc6-s390x [s390x],
          libc6-sparc64 [sparc64],
          libc6-mips64 [mips64 mips64el],
          libc6-mipsn32 [mipsn32 mipsn32el],
          libc6-mips32 [mips mipsel],
          hurd (<< 20120408-3) [hurd-i386]
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

Package: libc6-dev
Architecture: amd64 arc arm64 armel armhf hppa i386 loong64 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: libdevel
Priority: optional
Multi-Arch: same
Depends: libc6 (= ${binary:Version}) <!stage1>, libc-dev-bin (= ${binary:Version}), ${misc:Depends}, linux-libc-dev [linux-any], gnumach-dev [hurd-any], hurd-dev (>= 20080607-3) [hurd-any] | hurd-headers-dev [hurd-any], ${libcrypt-dev:Depends}, ${rpcsvc-proto:Depends}
Replaces: hurd-dev (<< 20120408-3) [hurd-any], libc6 (<= 2.32-1)
Suggests: glibc-doc, manpages-dev
Provides: libc-dev (= ${binary:Version}), libc6-dev [alpha hurd-any]

=== debian/rules ===
#! /usr/bin/make -f
# -*- makefile -*-
# debian/rules file for GNU libc.
# Copyright 1998, 1999 by Joel Klecker <espy@debian.org>
# Copyright 2000 Ben Collins <bcollins@debian.org>
# Copyright 2003 Jeff Bailey <jbailey@debian.org>
# This Makefile is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# What are the phases to building glibc?

# Unpack main tarball
# Do any necessary overlays
# Apply patches
# Determine how many builds there are to do.  For Each build:

#  Create build directory
#  Configure
#  Build
#  Test as desired
#  Install to package directories

# Run debian magic to build packages.

# Things you may need to customise:

# These are done as absolute paths so that in the case of filesystem size
# limitations, they can be overridden and spread all over.
build-tree := build-tree
debian-tmp = debian/tmp$(filter-out -libc,-$(curpass))
stamp := $(CURDIR)/stamp-dir/
DUMMY := $(shell mkdir -p $(stamp))

# Beyond here you shouldn't need to customise anything:
DEB_HOST_ARCH         ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_CPU     ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_ARCH_ENDIAN  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE     ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH    ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_BUILD_ARCH        ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_BUILD_ARCH_BITS   ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_BITS)
DEB_BUILD_GNU_TYPE    ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

include /usr/share/dpkg/pkg-info.mk

# The minimum package version with which these packages are compatible.
shlib_dep_ver = $(DEB_VERSION_UPSTREAM)
shlib_dep = $(libc) (>= $(shlib_dep_ver))

DEB_BUILDDIR ?= $(build-tree)/$(DEB_HOST_ARCH)-$(curpass)
DEB_BUILDDIRLIBC ?= $(build-tree)/$(DEB_HOST_ARCH)-libc

GLIBC_SOURCES = $(filter-out debian $(shell basename $(stamp)) $(build-tree), $(wildcard *))

# Support multiple makes at once based on number of processors
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# use the package settings, not the settings from the environment
define unsetenv
  unexport $(1)
  $(1) =
endef
$(foreach v, CPPFLAGS CFLAGS CXXFLAGS LDFLAGS, $(if $(filter environment,$(origin $(v))),$(eval $(call unsetenv, $(v)))))

# export debhelper substitution variables
export $(build-tree)

# Default setup
GLIBC_PASSES ?= libc

prefix=/usr
bindir=$(prefix)/bin
datadir=$(prefix)/share
complocaledir=$(prefix)/lib/locale
sysconfdir=/etc
libexecdir=$(prefix)/lib
rootsbindir=/sbin
includedir=$(prefix)/include
docdir=$(prefix)/share/doc
mandir=$(prefix)/share/man
sbindir=$(prefix)/sbin
vardbdir=/var/lib/misc
rtlddir=/lib
slibdir=/lib/$(DEB_HOST_MULTIARCH)
libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
mvec = no

rtld_so=$(shell awk 'BEGIN {FS="="} /^ld\.so-version/ {print $$2}' $(DEB_BUILDDIR)/soversions.mk)
rtld_target=$(shell readlink $(debian-tmp)$(rtlddir)/$(rtld_so))
libc_so=$(shell awk 'BEGIN {FS="="} /^libc\.so-version/ {print "libc.so"$$2}' $(DEB_BUILDDIR)/soversions.mk)

BASE_CC = gcc
BASE_CXX = g++
BASE_MIG = mig
# If you override DEB_GCC_VERSION, consider adding DEB_CFLAGS_APPEND=-Wno-error.
DEB_GCC_VERSION ?= -14

RUN_TESTSUITE = yes
TIMEOUTFACTOR = 25

# Set cross and native compiler names, including version.
CC     = $(DEB_HOST_GNU_TYPE)-$(BASE_CC)$(DEB_GCC_VERSION)
CXX    = $(DEB_HOST_GNU_TYPE)-$(BASE_CXX)$(DEB_GCC_VERSION)
MIG    = $(DEB_HOST_GNU_TYPE)-$(BASE_MIG)
BUILD_CC = $(DEB_BUILD_GNU_TYPE)-$(BASE_CC)
BUILD_CXX = $(DEB_BUILD_GNU_TYPE)-$(BASE_CXX)

BUILD_CFLAGS = -O2 -g -fdebug-prefix-map=$(CURDIR)=.
HOST_CFLAGS = -pipe -O2 -g -fdebug-prefix-map=$(CURDIR)=. $(call xx,extra_cflags)

# 32-bit MIPS builders have a 2GB memory space. This is not enough to
# build test-tgmath3.o with GCC, unless tweaking the garbage collector.
ifeq ($(findstring mips,$(DEB_BUILD_ARCH))-$(DEB_BUILD_ARCH_BITS), mips-32)
  CC += --param ggc-min-expand=10
endif

configure_target := $(DEB_HOST_GNU_TYPE)

# Normally we'll just use this for --build.  If the architecture requires
# that build daemons be able to run a particular optimized library, then
# they can set the --build to match --host for that optimized build.
# Among other things this lets tests run.
configure_build := $(DEB_BUILD_GNU_TYPE)

# Which build pass are we on?
curpass = $(filter-out %_,$(subst _,_ ,$@))

ifneq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  DEB_ARCH_REGULAR_PACKAGES = $(libc)-dev
  DEB_INDEP_REGULAR_PACKAGES =
  DEB_UDEB_PACKAGES =
  ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
    DEB_BUILD_OPTIONS+=nocheck
  endif
else
  DEB_ARCH_REGULAR_PACKAGES = $(libc) $(libc)-dev $(libc)-dbg libc-bin libc-dev-bin
  ifeq ($(filter stage2,$(DEB_BUILD_PROFILES)),)
    DEB_ARCH_REGULAR_PACKAGES += libc-devtools
  endif
  DEB_INDEP_REGULAR_PACKAGES = glibc-doc glibc-source libc-l10n locales
  ifneq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
    DEB_UDEB_PACKAGES =
  else
    DEB_UDEB_PACKAGES = $(libc)-udeb
  endif
  ## Locales can only be pre-generated during native compiles
  ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
    DEB_ARCH_REGULAR_PACKAGES += locales-all
  endif
endif

# Generic kernel version check
define kernel_check
(if [ $(CURRENT_KERNEL_VERSION) -lt $(1) ]; then \
  false; \
fi)
endef

# Include libidn for both NPTL and FBTL targets.
standard-add-ons = libidn,

# Pull in all the per-arch magic!

-include debian/sysdeps/$(DEB_HOST_ARCH_OS).mk
-include debian/sysdeps/$(DEB_HOST_ARCH).mk

ifneq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
DEB_ARCH_REGULAR_PACKAGES += $(foreach p,$(DEB_ARCH_MULTILIB_PACKAGES), $(if $(findstring -dev,$(p)), $(p)))
else
DEB_ARCH_REGULAR_PACKAGES += $(DEB_ARCH_MULTILIB_PACKAGES)
endif

# Don't run dh_strip on this package
NOSTRIP_$(libc)-dbg = 1

# Put the debug files from these packages in $(libc)-dbg
DEBUG_$(libc) = 1

ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  ifeq ($(threads),yes)
  DEB_ARCH_REGULAR_PACKAGES += nscd
  endif
endif

# And now the rules...
include debian/rules.d/*.mk

clean:: unpatch
	rm -rf $(patsubst %,debian/tmp-%,$(GLIBC_PASSES))
	rm -rf $(build-tree)
	rm -rf $(stamp)
	rm -rf debian/include
	rm -f debian/control.in/libc0.3	debian/control.in/libc6 debian/control.in/libc6.1 \
		debian/*.preinst.* debian/*.links.*

# Required Debian targets
build-arch: $(stamp)info \
	$(patsubst %,$(stamp)build_%,$(GLIBC_PASSES)) \
	$(patsubst %,$(stamp)check_%,$(GLIBC_PASSES)) \
	build-arch-post-check

ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
build-arch: $(stamp)build_C.utf8 \
	$(stamp)build_locales-all
endif

build-indep: $(stamp)source $(stamp)build_libc

build: build-arch build-indep


binary-indep: build-indep testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_INDEP_REGULAR_PACKAGES))

binary-arch: build-arch testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_ARCH_REGULAR_PACKAGES)) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_UDEB_PACKAGES))

binary: binary-indep binary-arch

testroot:
	dh_testroot

=== debian/tests/control ===
Tests: rebuild
Depends: @builddeps@, fakeroot, binutils, linux-libc-dev [linux-any], gcc-14
Restrictions: allow-stderr
